# WikitudeStudioAPIClient::AccountApi

All URIs are relative to *https://api-eu.wikitude.com/cloudrecognition*

| Method | HTTP request | Description |
| ------ | ------------ | ----------- |
| [**get_account**](AccountApi.md#get_account) | **GET** /account | Get account information |


## get_account

> <GetAccountInfoResponse> get_account(x_version, x_token)

Get account information

Request information regarding your account.

### Examples

```ruby
require 'time'
require 'wikitude_studio_api_client'

api_instance = WikitudeStudioAPIClient::AccountApi.new
x_version = '3' # String | The version of the API to be used. Must be set to 3.
x_token = 'x_token_example' # String | Your Manager Token.

begin
  # Get account information
  result = api_instance.get_account(x_version, x_token)
  p result
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling AccountApi->get_account: #{e}"
end
```

#### Using the get_account_with_http_info variant

This returns an Array which contains the response data, status code and headers.

> <Array(<GetAccountInfoResponse>, Integer, Hash)> get_account_with_http_info(x_version, x_token)

```ruby
begin
  # Get account information
  data, status_code, headers = api_instance.get_account_with_http_info(x_version, x_token)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <GetAccountInfoResponse>
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling AccountApi->get_account_with_http_info: #{e}"
end
```

### Parameters

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **x_version** | **String** | The version of the API to be used. Must be set to 3. |  |
| **x_token** | **String** | Your Manager Token. |  |

### Return type

[**GetAccountInfoResponse**](GetAccountInfoResponse.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

