# WikitudeStudioAPIClient::CloudArchiveGenerationResponse

## Properties

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **input_params** | [**CloudArchiveGenerationResponseInputParams**](CloudArchiveGenerationResponseInputParams.md) |  | [optional] |
| **created** | **Float** | Timestamp of the job creation. | [optional] |
| **estimated_start** | **Float** | Estimation of when the job will start processing. | [optional] |
| **estimated_end** | **Float** | Estimation of when the job will approximately be finished. | [optional] |
| **estimated_latency** | **Float** | Recommendation of when to first poll the corresponding status endpoint in milliseconds. | [optional] |
| **status** | **String** | The status of the asynchronous job. | [optional] |
| **tc_id** | **String** | Unique identifier of the Target Collection. | [optional] |
| **generation_id** | **String** | The asynchronous job id. | [optional] |

## Example

```ruby
require 'wikitude_studio_api_client'

instance = WikitudeStudioAPIClient::CloudArchiveGenerationResponse.new(
  input_params: null,
  created: 1597069526660,
  estimated_start: 1597069528660,
  estimated_end: 1597069533660,
  estimated_latency: 5000,
  status: SCHEDULED | RUNNING | FAILED | COMPLETED,
  tc_id: tcId00000000000000000001,
  generation_id: BykyFRRZw
)
```

