# WikitudeStudioAPIClient::GenerateWTCStatusResponse

## Properties

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **payload** | **Object** | Object containing job relevant results. | [optional] |
| **estimated_start** | **Float** | Estimation of when the job will start processing. | [optional] |
| **estimated_end** | **Float** | Estimation of when the job will approximately be finished. | [optional] |
| **status** | **String** | The status of the asynchronous job. | [optional] |
| **id** | **String** | Unique identifier of the Target Collection. | [optional] |
| **e_mail** | **String** | The e-mail address, the notification is sent after the generation of the resource is finished. | [optional] |
| **generation_id** | **String** | The asynchronous job id. | [optional] |
| **created** | **Float** | Timestamp of the job creation. | [optional] |
| **sdk_version** | **String** | Version of the Wikitude SDK the WTC resource was generated for. | [optional] |

## Example

```ruby
require 'wikitude_studio_api_client'

instance = WikitudeStudioAPIClient::GenerateWTCStatusResponse.new(
  payload: null,
  estimated_start: 1597069528660,
  estimated_end: 1597069533660,
  status: SCHEDULED | RUNNING | FAILED | COMPLETED,
  id: tcId00000000000000000001,
  e_mail: noreply@wikitude.com,
  generation_id: BykyFRRZw,
  created: 1597069526660,
  sdk_version: 8.5
)
```

