# WikitudeStudioAPIClient::ImageTargetCollectionResponse

## Properties

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **id** | **String** | Unique identifier of the Target Collection. | [optional] |
| **name** | **String** | Name of the Target Collection. | [optional] |
| **type** | **String** | Type of the Target Collection (\&quot;ImageTargetCollection\&quot; or \&quot;ObjectTargetCollection\&quot;). | [optional] |
| **wtc** | [**Array&lt;ImageTargetCollectionResponseWtc&gt;**](ImageTargetCollectionResponseWtc.md) | A list of generated WTC files. | [optional] |
| **mod_dat** | **Float** | Modification timestamp. | [optional] |
| **cre_dat** | **Float** | Creation timestamp. | [optional] |
| **metadata** | **Object** | Arbitrary JSON data that should be stored together with the Target Collection. | [optional] |
| **cloud_archive** | [**ImageTargetCollectionResponseCloudArchive**](ImageTargetCollectionResponseCloudArchive.md) |  | [optional] |

## Example

```ruby
require 'wikitude_studio_api_client'

instance = WikitudeStudioAPIClient::ImageTargetCollectionResponse.new(
  id: tcId00000000000000000001,
  name: Some Target Collection,
  type: ImageTargetCollection,
  wtc: null,
  mod_dat: 1597069533660,
  cre_dat: 1597069526660,
  metadata: {&quot;key&quot;:&quot;value&quot;},
  cloud_archive: null
)
```

