# WikitudeStudioAPIClient::ImageTargetResponse

## Properties

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **thumbnail_url** | **String** | URL to the Target resource thumbnail. | [optional] |
| **rating** | **Float** | The star rating indicates the quality of the target, i.e. how well the target is recognized on the device. The more stars a target has, the better it can be recognized and tracked.  | [optional] |
| **distribution** | **Float** | The distribution rating indicates how well feature-points scatter over the target image. The higher the rating, the more reliable it can be recognized and tracked, even if partly covered.  | [optional] |
| **file_size** | **Float** | File size of the stored resource. | [optional] |
| **name** | **String** | Name of the Target. | [optional] |
| **image_url** | **String** | URL to the Target Image resource. | [optional] |
| **type** | **String** | Type of the Target (\&quot;Image\&quot; for Image Targets or \&quot;Object\&quot; for Object Targets). | [optional] |
| **mod_dat** | **Float** | Modification timestamp. | [optional] |
| **cre_dat** | **Float** | Creation timestamp. | [optional] |
| **id** | **String** | Unique identifier of the Target. | [optional] |
| **metadata** | **String** | Arbitrary JSON data that should be stored together with the Target. | [optional] |
| **physical_height** | **Float** | The physical (real world) height of the target, in millimeters. | [optional] |

## Example

```ruby
require 'wikitude_studio_api_client'

instance = WikitudeStudioAPIClient::ImageTargetResponse.new(
  thumbnail_url: https://wikitudeUrl.com/img_thumb.jpg,
  rating: 3,
  distribution: 3,
  file_size: 1038481,
  name: Some Target,
  image_url: https://wikitudeUrl.com/img.jpg,
  type: Image,
  mod_dat: 1597069533660,
  cre_dat: 1597069526660,
  id: target000000000000000001,
  metadata: {&quot;key&quot;:&quot;value&quot;},
  physical_height: 42
)
```

