# WikitudeStudioAPIClient::ObjectTargetCollectionApi

All URIs are relative to *https://api-eu.wikitude.com/cloudrecognition*

| Method | HTTP request | Description |
| ------ | ------------ | ----------- |
| [**create_object_target_collection**](ObjectTargetCollectionApi.md#create_object_target_collection) | **POST** /objectTargetCollection | Create Object Target Collection |
| [**delete_object_target_collection**](ObjectTargetCollectionApi.md#delete_object_target_collection) | **DELETE** /objectTargetCollection/{tcId} | Delete Object Target Collection |
| [**generate_wto**](ObjectTargetCollectionApi.md#generate_wto) | **POST** /objectTargetCollection/{tcId}/generation/wto | Generate WTO |
| [**get_object_target_collection**](ObjectTargetCollectionApi.md#get_object_target_collection) | **GET** /objectTargetCollection/{tcId} | Get Object Target Collection |
| [**get_object_target_collection_status**](ObjectTargetCollectionApi.md#get_object_target_collection_status) | **GET** /objectTargetCollection/{tcId}/jobs | Status - Get Object Target Collection jobs |
| [**get_object_target_collections**](ObjectTargetCollectionApi.md#get_object_target_collections) | **GET** /objectTargetCollection | Get all Object Target Collections |
| [**get_wto_status**](ObjectTargetCollectionApi.md#get_wto_status) | **GET** /objectTargetCollection/{tcId}/generation/wto/{generationId} | Status - Generate WTO |
| [**update_object_target_collection**](ObjectTargetCollectionApi.md#update_object_target_collection) | **PUT** /objectTargetCollection/{tcId} | Update Object Target Collection |


## create_object_target_collection

> <ObjectTargetCollectionResponse> create_object_target_collection(x_version, x_token, content_type, create_object_target_collection_body)

Create Object Target Collection

Create a new Object Target Collection in your account.

### Examples

```ruby
require 'time'
require 'wikitude_studio_api_client'

api_instance = WikitudeStudioAPIClient::ObjectTargetCollectionApi.new
x_version = '3' # String | The version of the API to be used. Must be set to 3.
x_token = 'x_token_example' # String | Your Manager Token.
content_type = 'content_type_example' # String | The Content Type of the body. Must be set to application/json.
create_object_target_collection_body = WikitudeStudioAPIClient::CreateObjectTargetCollectionBody.new # CreateObjectTargetCollectionBody | 

begin
  # Create Object Target Collection
  result = api_instance.create_object_target_collection(x_version, x_token, content_type, create_object_target_collection_body)
  p result
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->create_object_target_collection: #{e}"
end
```

#### Using the create_object_target_collection_with_http_info variant

This returns an Array which contains the response data, status code and headers.

> <Array(<ObjectTargetCollectionResponse>, Integer, Hash)> create_object_target_collection_with_http_info(x_version, x_token, content_type, create_object_target_collection_body)

```ruby
begin
  # Create Object Target Collection
  data, status_code, headers = api_instance.create_object_target_collection_with_http_info(x_version, x_token, content_type, create_object_target_collection_body)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <ObjectTargetCollectionResponse>
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->create_object_target_collection_with_http_info: #{e}"
end
```

### Parameters

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **x_version** | **String** | The version of the API to be used. Must be set to 3. |  |
| **x_token** | **String** | Your Manager Token. |  |
| **content_type** | **String** | The Content Type of the body. Must be set to application/json. |  |
| **create_object_target_collection_body** | [**CreateObjectTargetCollectionBody**](CreateObjectTargetCollectionBody.md) |  |  |

### Return type

[**ObjectTargetCollectionResponse**](ObjectTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## delete_object_target_collection

> delete_object_target_collection(x_version, x_token, tc_id)

Delete Object Target Collection

Delete a Object Target Collection and all its Object Targets.

### Examples

```ruby
require 'time'
require 'wikitude_studio_api_client'

api_instance = WikitudeStudioAPIClient::ObjectTargetCollectionApi.new
x_version = '3' # String | The version of the API to be used. Must be set to 3.
x_token = 'x_token_example' # String | Your Manager Token.
tc_id = 'tc_id_example' # String | Unique identifier of the Object Target Collection.

begin
  # Delete Object Target Collection
  api_instance.delete_object_target_collection(x_version, x_token, tc_id)
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->delete_object_target_collection: #{e}"
end
```

#### Using the delete_object_target_collection_with_http_info variant

This returns an Array which contains the response data (`nil` in this case), status code and headers.

> <Array(nil, Integer, Hash)> delete_object_target_collection_with_http_info(x_version, x_token, tc_id)

```ruby
begin
  # Delete Object Target Collection
  data, status_code, headers = api_instance.delete_object_target_collection_with_http_info(x_version, x_token, tc_id)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => nil
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->delete_object_target_collection_with_http_info: #{e}"
end
```

### Parameters

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **x_version** | **String** | The version of the API to be used. Must be set to 3. |  |
| **x_token** | **String** | Your Manager Token. |  |
| **tc_id** | **String** | Unique identifier of the Object Target Collection. |  |

### Return type

nil (empty response body)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: Not defined


## generate_wto

> <ObjectTargetCollectionJobResponse> generate_wto(x_version, x_token, content_type, tc_id, generate_wto_body)

Generate WTO

Generate a WTO file containing the Object Target Collection and all its Object Targets.

### Examples

```ruby
require 'time'
require 'wikitude_studio_api_client'

api_instance = WikitudeStudioAPIClient::ObjectTargetCollectionApi.new
x_version = '3' # String | The version of the API to be used. Must be set to 3.
x_token = 'x_token_example' # String | Your Manager Token.
content_type = 'content_type_example' # String | The Content Type of the body. Must be set to application/json.
tc_id = 'tc_id_example' # String | Unique identifier of the Object Target Collection.
generate_wto_body = WikitudeStudioAPIClient::GenerateWTOBody.new # GenerateWTOBody | 

begin
  # Generate WTO
  result = api_instance.generate_wto(x_version, x_token, content_type, tc_id, generate_wto_body)
  p result
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->generate_wto: #{e}"
end
```

#### Using the generate_wto_with_http_info variant

This returns an Array which contains the response data, status code and headers.

> <Array(<ObjectTargetCollectionJobResponse>, Integer, Hash)> generate_wto_with_http_info(x_version, x_token, content_type, tc_id, generate_wto_body)

```ruby
begin
  # Generate WTO
  data, status_code, headers = api_instance.generate_wto_with_http_info(x_version, x_token, content_type, tc_id, generate_wto_body)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <ObjectTargetCollectionJobResponse>
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->generate_wto_with_http_info: #{e}"
end
```

### Parameters

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **x_version** | **String** | The version of the API to be used. Must be set to 3. |  |
| **x_token** | **String** | Your Manager Token. |  |
| **content_type** | **String** | The Content Type of the body. Must be set to application/json. |  |
| **tc_id** | **String** | Unique identifier of the Object Target Collection. |  |
| **generate_wto_body** | [**GenerateWTOBody**](GenerateWTOBody.md) |  |  |

### Return type

[**ObjectTargetCollectionJobResponse**](ObjectTargetCollectionJobResponse.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## get_object_target_collection

> <ObjectTargetCollectionResponse> get_object_target_collection(x_version, x_token, tc_id)

Get Object Target Collection

Request a particular Object Target Collection from your account.

### Examples

```ruby
require 'time'
require 'wikitude_studio_api_client'

api_instance = WikitudeStudioAPIClient::ObjectTargetCollectionApi.new
x_version = '3' # String | The version of the API to be used. Must be set to 3.
x_token = 'x_token_example' # String | Your Manager Token.
tc_id = 'tc_id_example' # String | Unique identifier of the Object Target Collection.

begin
  # Get Object Target Collection
  result = api_instance.get_object_target_collection(x_version, x_token, tc_id)
  p result
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->get_object_target_collection: #{e}"
end
```

#### Using the get_object_target_collection_with_http_info variant

This returns an Array which contains the response data, status code and headers.

> <Array(<ObjectTargetCollectionResponse>, Integer, Hash)> get_object_target_collection_with_http_info(x_version, x_token, tc_id)

```ruby
begin
  # Get Object Target Collection
  data, status_code, headers = api_instance.get_object_target_collection_with_http_info(x_version, x_token, tc_id)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <ObjectTargetCollectionResponse>
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->get_object_target_collection_with_http_info: #{e}"
end
```

### Parameters

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **x_version** | **String** | The version of the API to be used. Must be set to 3. |  |
| **x_token** | **String** | Your Manager Token. |  |
| **tc_id** | **String** | Unique identifier of the Object Target Collection. |  |

### Return type

[**ObjectTargetCollectionResponse**](ObjectTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## get_object_target_collection_status

> <Array<ObjectTargetJobResponse>> get_object_target_collection_status(x_version, x_token, tc_id, opts)

Status - Get Object Target Collection jobs

Retrieves a list of asynchronous jobs sorted by creation date.

### Examples

```ruby
require 'time'
require 'wikitude_studio_api_client'

api_instance = WikitudeStudioAPIClient::ObjectTargetCollectionApi.new
x_version = '3' # String | The version of the API to be used. Must be set to 3.
x_token = 'x_token_example' # String | Your Manager Token.
tc_id = 'tc_id_example' # String | Unique identifier of the Object Target Collection.
opts = {
  skip: 0, # Integer | Set 0 to start with first collection, set e.g. to 2 to skip first 2 collections. Default value: 0
  limit: 1000, # Integer | Use positive value to define the amount of entries to return [1, 20] per page. Default value: 10
  source: 'api', # String | filter the jobs by source. Available values (api, studio). Default value: api
  type: 'api' # String | filter the jobs by type.
}

begin
  # Status - Get Object Target Collection jobs
  result = api_instance.get_object_target_collection_status(x_version, x_token, tc_id, opts)
  p result
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->get_object_target_collection_status: #{e}"
end
```

#### Using the get_object_target_collection_status_with_http_info variant

This returns an Array which contains the response data, status code and headers.

> <Array(<Array<ObjectTargetJobResponse>>, Integer, Hash)> get_object_target_collection_status_with_http_info(x_version, x_token, tc_id, opts)

```ruby
begin
  # Status - Get Object Target Collection jobs
  data, status_code, headers = api_instance.get_object_target_collection_status_with_http_info(x_version, x_token, tc_id, opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <Array<ObjectTargetJobResponse>>
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->get_object_target_collection_status_with_http_info: #{e}"
end
```

### Parameters

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **x_version** | **String** | The version of the API to be used. Must be set to 3. |  |
| **x_token** | **String** | Your Manager Token. |  |
| **tc_id** | **String** | Unique identifier of the Object Target Collection. |  |
| **skip** | **Integer** | Set 0 to start with first collection, set e.g. to 2 to skip first 2 collections. Default value: 0 | [optional] |
| **limit** | **Integer** | Use positive value to define the amount of entries to return [1, 20] per page. Default value: 10 | [optional] |
| **source** | **String** | filter the jobs by source. Available values (api, studio). Default value: api | [optional] |
| **type** | **String** | filter the jobs by type. | [optional] |

### Return type

[**Array&lt;ObjectTargetJobResponse&gt;**](ObjectTargetJobResponse.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## get_object_target_collections

> <Array<ObjectTargetCollectionResponse>> get_object_target_collections(x_version, x_token, opts)

Get all Object Target Collections

Request all Object Target Collections from your account.

### Examples

```ruby
require 'time'
require 'wikitude_studio_api_client'

api_instance = WikitudeStudioAPIClient::ObjectTargetCollectionApi.new
x_version = '3' # String | The version of the API to be used. Must be set to 3.
x_token = 'x_token_example' # String | Your Manager Token.
opts = {
  skip: 56, # Integer | Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0
  limit: 56 # Integer | Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000
}

begin
  # Get all Object Target Collections
  result = api_instance.get_object_target_collections(x_version, x_token, opts)
  p result
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->get_object_target_collections: #{e}"
end
```

#### Using the get_object_target_collections_with_http_info variant

This returns an Array which contains the response data, status code and headers.

> <Array(<Array<ObjectTargetCollectionResponse>>, Integer, Hash)> get_object_target_collections_with_http_info(x_version, x_token, opts)

```ruby
begin
  # Get all Object Target Collections
  data, status_code, headers = api_instance.get_object_target_collections_with_http_info(x_version, x_token, opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <Array<ObjectTargetCollectionResponse>>
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->get_object_target_collections_with_http_info: #{e}"
end
```

### Parameters

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **x_version** | **String** | The version of the API to be used. Must be set to 3. |  |
| **x_token** | **String** | Your Manager Token. |  |
| **skip** | **Integer** | Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 | [optional] |
| **limit** | **Integer** | Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 | [optional] |

### Return type

[**Array&lt;ObjectTargetCollectionResponse&gt;**](ObjectTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## get_wto_status

> <ObjectTargetCollectionJobResponse> get_wto_status(x_version, x_token, tc_id, generation_id)

Status - Generate WTO

Retrieves information status about a particular scheduled wto generation.

### Examples

```ruby
require 'time'
require 'wikitude_studio_api_client'

api_instance = WikitudeStudioAPIClient::ObjectTargetCollectionApi.new
x_version = '3' # String | The version of the API to be used. Must be set to 3.
x_token = 'x_token_example' # String | Your Manager Token.
tc_id = 'tc_id_example' # String | Unique identifier of the Object Target Collection.
generation_id = 'generation_id_example' # String | Unique identifier of the asynchronous job created by a generation endpoint.

begin
  # Status - Generate WTO
  result = api_instance.get_wto_status(x_version, x_token, tc_id, generation_id)
  p result
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->get_wto_status: #{e}"
end
```

#### Using the get_wto_status_with_http_info variant

This returns an Array which contains the response data, status code and headers.

> <Array(<ObjectTargetCollectionJobResponse>, Integer, Hash)> get_wto_status_with_http_info(x_version, x_token, tc_id, generation_id)

```ruby
begin
  # Status - Generate WTO
  data, status_code, headers = api_instance.get_wto_status_with_http_info(x_version, x_token, tc_id, generation_id)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <ObjectTargetCollectionJobResponse>
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->get_wto_status_with_http_info: #{e}"
end
```

### Parameters

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **x_version** | **String** | The version of the API to be used. Must be set to 3. |  |
| **x_token** | **String** | Your Manager Token. |  |
| **tc_id** | **String** | Unique identifier of the Object Target Collection. |  |
| **generation_id** | **String** | Unique identifier of the asynchronous job created by a generation endpoint. |  |

### Return type

[**ObjectTargetCollectionJobResponse**](ObjectTargetCollectionJobResponse.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## update_object_target_collection

> <ObjectTargetCollectionResponse> update_object_target_collection(x_version, x_token, content_type, tc_id, update_object_target_collection_body)

Update Object Target Collection

Updates an existing Object Target Collection in your account.

### Examples

```ruby
require 'time'
require 'wikitude_studio_api_client'

api_instance = WikitudeStudioAPIClient::ObjectTargetCollectionApi.new
x_version = '3' # String | The version of the API to be used. Must be set to 3.
x_token = 'x_token_example' # String | Your Manager Token.
content_type = 'content_type_example' # String | The Content Type of the body. Must be set to application/json.
tc_id = 'tc_id_example' # String | Unique identifier of the Object Target Collection.
update_object_target_collection_body = WikitudeStudioAPIClient::UpdateObjectTargetCollectionBody.new # UpdateObjectTargetCollectionBody | 

begin
  # Update Object Target Collection
  result = api_instance.update_object_target_collection(x_version, x_token, content_type, tc_id, update_object_target_collection_body)
  p result
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->update_object_target_collection: #{e}"
end
```

#### Using the update_object_target_collection_with_http_info variant

This returns an Array which contains the response data, status code and headers.

> <Array(<ObjectTargetCollectionResponse>, Integer, Hash)> update_object_target_collection_with_http_info(x_version, x_token, content_type, tc_id, update_object_target_collection_body)

```ruby
begin
  # Update Object Target Collection
  data, status_code, headers = api_instance.update_object_target_collection_with_http_info(x_version, x_token, content_type, tc_id, update_object_target_collection_body)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <ObjectTargetCollectionResponse>
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ObjectTargetCollectionApi->update_object_target_collection_with_http_info: #{e}"
end
```

### Parameters

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **x_version** | **String** | The version of the API to be used. Must be set to 3. |  |
| **x_token** | **String** | Your Manager Token. |  |
| **content_type** | **String** | The Content Type of the body. Must be set to application/json. |  |
| **tc_id** | **String** | Unique identifier of the Object Target Collection. |  |
| **update_object_target_collection_body** | [**UpdateObjectTargetCollectionBody**](UpdateObjectTargetCollectionBody.md) |  |  |

### Return type

[**ObjectTargetCollectionResponse**](ObjectTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

