# WikitudeStudioAPIClient::ObjectTargetCollectionResponse

## Properties

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **name** | **String** | Name of the Target Collection. | [optional] |
| **metadata** | **Object** | Arbitrary JSON data that should be stored together with the Target Collection. | [optional] |
| **type** | **String** | Type of the Target Collection (\&quot;ImageTargetCollection\&quot; or \&quot;ObjectTargetCollection\&quot;). | [optional] |
| **sdk_version** | **String** | Version of the Wikitude SDK the WTO resource is generated for. | [optional] |
| **mod_dat** | **Float** | Modification timestamp. | [optional] |
| **cre_dat** | **Float** | Creation timestamp. | [optional] |
| **wto** | [**Array&lt;ObjectTargetCollectionResponseWto&gt;**](ObjectTargetCollectionResponseWto.md) | A list of generated WTO files. | [optional] |
| **id** | **String** | Unique identifier of the Target Collection. | [optional] |

## Example

```ruby
require 'wikitude_studio_api_client'

instance = WikitudeStudioAPIClient::ObjectTargetCollectionResponse.new(
  name: Some Target Collection,
  metadata: {&quot;key&quot;:&quot;value&quot;},
  type: ObjectTargetCollection,
  sdk_version: 8.0,
  mod_dat: 1597069533660,
  cre_dat: 1597069526660,
  wto: null,
  id: tcId00000000000000000001
)
```

