# WikitudeStudioAPIClient::ObjectTargetResponse

## Properties

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **id** | **String** | Unique identifier of the Target. | [optional] |
| **name** | **String** | Name of the Target. | [optional] |
| **type** | **String** | Type of the Target (\&quot;Image\&quot; for Image Targets or \&quot;Object\&quot; for Object Targets). | [optional] |
| **file_size** | **Float** | File size of the stored resource. | [optional] |
| **mod_dat** | **Float** | Modification timestamp. | [optional] |
| **cre_dat** | **Float** | Creation timestamp. | [optional] |
| **is_expandable** | **Boolean** | Indicates if an Object Target is extendable to improve tracking and recognition quality. Only Image-based Object Targets are extendable.  | [optional] |
| **real_world_scale** | **Float** | The physical (real world) size of the Target, in millimeters. Set to null to reset. | [optional] |
| **resource** | [**ObjectTargetResponseResource**](ObjectTargetResponseResource.md) |  | [optional] |
| **thumbnail_url** | **String** | URL to the Target resource thumbnail. | [optional] |
| **wto_file** | [**ObjectTargetResponseWtoFile**](ObjectTargetResponseWtoFile.md) |  | [optional] |

## Example

```ruby
require 'wikitude_studio_api_client'

instance = WikitudeStudioAPIClient::ObjectTargetResponse.new(
  id: target000000000000000001,
  name: Some Target,
  type: Object,
  file_size: 1038481,
  mod_dat: 1597069533660,
  cre_dat: 1597069526660,
  is_expandable: true,
  real_world_scale: 42,
  resource: null,
  thumbnail_url: https://wikitudeUrl.com/img_thumb.jpg,
  wto_file: null
)
```

