# WikitudeStudioAPIClient::ProjectApi

All URIs are relative to *https://api-eu.wikitude.com/cloudrecognition*

| Method | HTTP request | Description |
| ------ | ------------ | ----------- |
| [**get_projects**](ProjectApi.md#get_projects) | **GET** /projects | Get all projects |


## get_projects

> <Array<AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse>> get_projects(x_version, x_token, opts)

Get all projects

Request all projects from your account.

### Examples

```ruby
require 'time'
require 'wikitude_studio_api_client'

api_instance = WikitudeStudioAPIClient::ProjectApi.new
x_version = '3' # String | The version of the API to be used. Must be set to 3.
x_token = 'x_token_example' # String | Your Manager Token.
opts = {
  skip: 56, # Integer | Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0
  limit: 56 # Integer | Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000
}

begin
  # Get all projects
  result = api_instance.get_projects(x_version, x_token, opts)
  p result
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ProjectApi->get_projects: #{e}"
end
```

#### Using the get_projects_with_http_info variant

This returns an Array which contains the response data, status code and headers.

> <Array(<Array<AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse>>, Integer, Hash)> get_projects_with_http_info(x_version, x_token, opts)

```ruby
begin
  # Get all projects
  data, status_code, headers = api_instance.get_projects_with_http_info(x_version, x_token, opts)
  p status_code # => 2xx
  p headers # => { ... }
  p data # => <Array<AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse>>
rescue WikitudeStudioAPIClient::ApiError => e
  puts "Error when calling ProjectApi->get_projects_with_http_info: #{e}"
end
```

### Parameters

| Name | Type | Description | Notes |
| ---- | ---- | ----------- | ----- |
| **x_version** | **String** | The version of the API to be used. Must be set to 3. |  |
| **x_token** | **String** | Your Manager Token. |  |
| **skip** | **Integer** | Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 | [optional] |
| **limit** | **Integer** | Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 | [optional] |

### Return type

[**Array&lt;AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse&gt;**](AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

