=begin
#Wikitude Studio API

#The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 

The version of the OpenAPI document: 3.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0

=end

# Common files
require 'wikitude_studio_api_client/api_client'
require 'wikitude_studio_api_client/api_error'
require 'wikitude_studio_api_client/version'
require 'wikitude_studio_api_client/configuration'

# Models
require 'wikitude_studio_api_client/models/cloud_archive_generation_response'
require 'wikitude_studio_api_client/models/cloud_archive_generation_response_input_params'
require 'wikitude_studio_api_client/models/create_image_target_collection_body'
require 'wikitude_studio_api_client/models/create_image_target_collection_body_cloud_archive'
require 'wikitude_studio_api_client/models/create_image_targets_body'
require 'wikitude_studio_api_client/models/create_image_targets_response'
require 'wikitude_studio_api_client/models/create_image_targets_response_input_params'
require 'wikitude_studio_api_client/models/create_image_targets_response_input_params_targets'
require 'wikitude_studio_api_client/models/create_object_target_collection_body'
require 'wikitude_studio_api_client/models/create_object_target_images_body'
require 'wikitude_studio_api_client/models/create_object_target_images_body_resource'
require 'wikitude_studio_api_client/models/create_object_target_wto_body'
require 'wikitude_studio_api_client/models/create_object_target_wto_body_resource'
require 'wikitude_studio_api_client/models/extend_object_target_body'
require 'wikitude_studio_api_client/models/generate_heatmap_body'
require 'wikitude_studio_api_client/models/generate_heatmap_response'
require 'wikitude_studio_api_client/models/generate_heatmap_response_input_params'
require 'wikitude_studio_api_client/models/generate_heatmap_status_response'
require 'wikitude_studio_api_client/models/generate_heatmap_status_response_payload'
require 'wikitude_studio_api_client/models/generate_wtc_body'
require 'wikitude_studio_api_client/models/generate_wtc_status_response'
require 'wikitude_studio_api_client/models/generate_wto_body'
require 'wikitude_studio_api_client/models/get_account_info_response'
require 'wikitude_studio_api_client/models/get_account_info_response_storage'
require 'wikitude_studio_api_client/models/image_target_collection_response'
require 'wikitude_studio_api_client/models/image_target_collection_response_cloud_archive'
require 'wikitude_studio_api_client/models/image_target_collection_response_wtc'
require 'wikitude_studio_api_client/models/image_target_response'
require 'wikitude_studio_api_client/models/object_target_collection_job_response'
require 'wikitude_studio_api_client/models/object_target_collection_response'
require 'wikitude_studio_api_client/models/object_target_collection_response_wto'
require 'wikitude_studio_api_client/models/object_target_job_response'
require 'wikitude_studio_api_client/models/object_target_response'
require 'wikitude_studio_api_client/models/object_target_response_resource'
require 'wikitude_studio_api_client/models/object_target_response_wto_file'
require 'wikitude_studio_api_client/models/rename_object_target_body'
require 'wikitude_studio_api_client/models/similarity_check_body'
require 'wikitude_studio_api_client/models/similarity_check_body_images'
require 'wikitude_studio_api_client/models/similarity_check_response'
require 'wikitude_studio_api_client/models/similarity_check_response_input_params'
require 'wikitude_studio_api_client/models/similarity_check_response_input_params_images'
require 'wikitude_studio_api_client/models/similarity_check_status_response'
require 'wikitude_studio_api_client/models/similarity_check_status_response_candidates'
require 'wikitude_studio_api_client/models/similarity_check_status_response_input_params'
require 'wikitude_studio_api_client/models/similarity_check_status_response_payload'
require 'wikitude_studio_api_client/models/update_image_target_body'
require 'wikitude_studio_api_client/models/update_image_target_collection_body'
require 'wikitude_studio_api_client/models/update_object_target_collection_body'

# APIs
require 'wikitude_studio_api_client/api/account_api'
require 'wikitude_studio_api_client/api/heatmap_api'
require 'wikitude_studio_api_client/api/image_target_api'
require 'wikitude_studio_api_client/api/image_target_collection_api'
require 'wikitude_studio_api_client/api/object_target_api'
require 'wikitude_studio_api_client/api/object_target_collection_api'
require 'wikitude_studio_api_client/api/project_api'

module WikitudeStudioAPIClient
  class << self
    # Customize default settings for the SDK using block.
    #   WikitudeStudioAPIClient.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
