=begin
#Wikitude Studio API

#The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 

The version of the OpenAPI document: 3.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0

=end

require 'cgi'

module WikitudeStudioAPIClient
  class HeatmapApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Generate Heatmap
    # Generates a greyscale image out of the input image, where areas with recognition and tracking relevance are highlighted in color. This way one can better understand the rating of an image and see which areas have the highest importance for 2D recognition and tracking. Note that only JPG and non-transparent PNG files are accepted and the generated heatmap image is stored on a temporary folder which is deleted after 24 hours. Store the image on your own server in case you plan to use it in your user interface. 
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param generate_heatmap_body [GenerateHeatmapBody] 
    # @param [Hash] opts the optional parameters
    # @return [GenerateHeatmapResponse]
    def generate_heatmap(x_version, x_token, content_type, generate_heatmap_body, opts = {})
      data, _status_code, _headers = generate_heatmap_with_http_info(x_version, x_token, content_type, generate_heatmap_body, opts)
      data
    end

    # Generate Heatmap
    # Generates a greyscale image out of the input image, where areas with recognition and tracking relevance are highlighted in color. This way one can better understand the rating of an image and see which areas have the highest importance for 2D recognition and tracking. Note that only JPG and non-transparent PNG files are accepted and the generated heatmap image is stored on a temporary folder which is deleted after 24 hours. Store the image on your own server in case you plan to use it in your user interface. 
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param generate_heatmap_body [GenerateHeatmapBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(GenerateHeatmapResponse, Integer, Hash)>] GenerateHeatmapResponse data, response status code and response headers
    def generate_heatmap_with_http_info(x_version, x_token, content_type, generate_heatmap_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HeatmapApi.generate_heatmap ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling HeatmapApi.generate_heatmap"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling HeatmapApi.generate_heatmap"
      end
      # verify the required parameter 'content_type' is set
      if @api_client.config.client_side_validation && content_type.nil?
        fail ArgumentError, "Missing the required parameter 'content_type' when calling HeatmapApi.generate_heatmap"
      end
      # verify the required parameter 'generate_heatmap_body' is set
      if @api_client.config.client_side_validation && generate_heatmap_body.nil?
        fail ArgumentError, "Missing the required parameter 'generate_heatmap_body' when calling HeatmapApi.generate_heatmap"
      end
      # resource path
      local_var_path = '/heatmap'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token
      header_params[:'Content-Type'] = content_type

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(generate_heatmap_body)

      # return_type
      return_type = opts[:debug_return_type] || 'GenerateHeatmapResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"HeatmapApi.generate_heatmap",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HeatmapApi#generate_heatmap\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Status - Generate Heatmap
    # Retrieves information status about a particular scheduled heatmap creation.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param generation_id [String] Unique identifier of the asynchronous job created by a generation endpoint.
    # @param [Hash] opts the optional parameters
    # @return [GenerateHeatmapStatusResponse]
    def get_heatmap_status(x_version, x_token, generation_id, opts = {})
      data, _status_code, _headers = get_heatmap_status_with_http_info(x_version, x_token, generation_id, opts)
      data
    end

    # Status - Generate Heatmap
    # Retrieves information status about a particular scheduled heatmap creation.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param generation_id [String] Unique identifier of the asynchronous job created by a generation endpoint.
    # @param [Hash] opts the optional parameters
    # @return [Array<(GenerateHeatmapStatusResponse, Integer, Hash)>] GenerateHeatmapStatusResponse data, response status code and response headers
    def get_heatmap_status_with_http_info(x_version, x_token, generation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: HeatmapApi.get_heatmap_status ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling HeatmapApi.get_heatmap_status"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling HeatmapApi.get_heatmap_status"
      end
      # verify the required parameter 'generation_id' is set
      if @api_client.config.client_side_validation && generation_id.nil?
        fail ArgumentError, "Missing the required parameter 'generation_id' when calling HeatmapApi.get_heatmap_status"
      end
      # resource path
      local_var_path = '/heatmap/{generationId}'.sub('{' + 'generationId' + '}', CGI.escape(generation_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'GenerateHeatmapStatusResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"HeatmapApi.get_heatmap_status",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: HeatmapApi#get_heatmap_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
