=begin
#Wikitude Studio API

#The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 

The version of the OpenAPI document: 3.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0

=end

require 'cgi'

module WikitudeStudioAPIClient
  class ImageTargetApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create Image Targets
    # Create a set of up to 10 new Targets in a Target Collection in your account. The task to create the listed Targets is scheduled. The response body contains the initial job status. \"Location\"-header is the url to the GET endpoint that returns current job status information. It is recommended to query this endpoint after \"estimatedLatency\" milliseconds, and poll it afterwards every 10 seconds in case job status is still not \"COMPLETED\". Once job status is \"COMPLETED\" each item holds a \"target\" attribute of the created target or an \"error\" attribute. 
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<CreateImageTargetsBody>] :create_image_targets_body 
    # @return [CreateImageTargetsResponse]
    def create_image_targets(x_version, x_token, content_type, tc_id, opts = {})
      data, _status_code, _headers = create_image_targets_with_http_info(x_version, x_token, content_type, tc_id, opts)
      data
    end

    # Create Image Targets
    # Create a set of up to 10 new Targets in a Target Collection in your account. The task to create the listed Targets is scheduled. The response body contains the initial job status. \&quot;Location\&quot;-header is the url to the GET endpoint that returns current job status information. It is recommended to query this endpoint after \&quot;estimatedLatency\&quot; milliseconds, and poll it afterwards every 10 seconds in case job status is still not \&quot;COMPLETED\&quot;. Once job status is \&quot;COMPLETED\&quot; each item holds a \&quot;target\&quot; attribute of the created target or an \&quot;error\&quot; attribute. 
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param [Hash] opts the optional parameters
    # @option opts [Array<CreateImageTargetsBody>] :create_image_targets_body 
    # @return [Array<(CreateImageTargetsResponse, Integer, Hash)>] CreateImageTargetsResponse data, response status code and response headers
    def create_image_targets_with_http_info(x_version, x_token, content_type, tc_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetApi.create_image_targets ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetApi.create_image_targets"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetApi.create_image_targets"
      end
      # verify the required parameter 'content_type' is set
      if @api_client.config.client_side_validation && content_type.nil?
        fail ArgumentError, "Missing the required parameter 'content_type' when calling ImageTargetApi.create_image_targets"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ImageTargetApi.create_image_targets"
      end
      # resource path
      local_var_path = '/targetCollection/{tcId}/targets'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token
      header_params[:'Content-Type'] = content_type

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(opts[:'create_image_targets_body'])

      # return_type
      return_type = opts[:debug_return_type] || 'CreateImageTargetsResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetApi.create_image_targets",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetApi#create_image_targets\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete Image Target
    # Delete a particular Target from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param target_id [String] Unique identifier of the Image Target.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_image_target(x_version, x_token, tc_id, target_id, opts = {})
      delete_image_target_with_http_info(x_version, x_token, tc_id, target_id, opts)
      nil
    end

    # Delete Image Target
    # Delete a particular Target from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param target_id [String] Unique identifier of the Image Target.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_image_target_with_http_info(x_version, x_token, tc_id, target_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetApi.delete_image_target ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetApi.delete_image_target"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetApi.delete_image_target"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ImageTargetApi.delete_image_target"
      end
      # verify the required parameter 'target_id' is set
      if @api_client.config.client_side_validation && target_id.nil?
        fail ArgumentError, "Missing the required parameter 'target_id' when calling ImageTargetApi.delete_image_target"
      end
      # resource path
      local_var_path = '/targetCollection/{tcId}/target/{targetId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s)).sub('{' + 'targetId' + '}', CGI.escape(target_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type]

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetApi.delete_image_target",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetApi#delete_image_target\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Image Target
    # Request a particular Image Target in a particular Target Collection.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param target_id [String] Unique identifier of the Image Target.
    # @param [Hash] opts the optional parameters
    # @return [ImageTargetResponse]
    def get_image_target(x_version, x_token, tc_id, target_id, opts = {})
      data, _status_code, _headers = get_image_target_with_http_info(x_version, x_token, tc_id, target_id, opts)
      data
    end

    # Get Image Target
    # Request a particular Image Target in a particular Target Collection.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param target_id [String] Unique identifier of the Image Target.
    # @param [Hash] opts the optional parameters
    # @return [Array<(ImageTargetResponse, Integer, Hash)>] ImageTargetResponse data, response status code and response headers
    def get_image_target_with_http_info(x_version, x_token, tc_id, target_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetApi.get_image_target ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetApi.get_image_target"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetApi.get_image_target"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ImageTargetApi.get_image_target"
      end
      # verify the required parameter 'target_id' is set
      if @api_client.config.client_side_validation && target_id.nil?
        fail ArgumentError, "Missing the required parameter 'target_id' when calling ImageTargetApi.get_image_target"
      end
      # resource path
      local_var_path = '/targetCollection/{tcId}/target/{targetId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s)).sub('{' + 'targetId' + '}', CGI.escape(target_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'ImageTargetResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetApi.get_image_target",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetApi#get_image_target\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Status - Image Targets Creation
    # Retrieves information status about a particular scheduled targets creation.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param generation_id [String] Unique identifier of the asynchronous job created by a generation endpoint.
    # @param [Hash] opts the optional parameters
    # @return [CreateImageTargetsResponse]
    def get_image_target_status(x_version, x_token, tc_id, generation_id, opts = {})
      data, _status_code, _headers = get_image_target_status_with_http_info(x_version, x_token, tc_id, generation_id, opts)
      data
    end

    # Status - Image Targets Creation
    # Retrieves information status about a particular scheduled targets creation.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param generation_id [String] Unique identifier of the asynchronous job created by a generation endpoint.
    # @param [Hash] opts the optional parameters
    # @return [Array<(CreateImageTargetsResponse, Integer, Hash)>] CreateImageTargetsResponse data, response status code and response headers
    def get_image_target_status_with_http_info(x_version, x_token, tc_id, generation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetApi.get_image_target_status ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetApi.get_image_target_status"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetApi.get_image_target_status"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ImageTargetApi.get_image_target_status"
      end
      # verify the required parameter 'generation_id' is set
      if @api_client.config.client_side_validation && generation_id.nil?
        fail ArgumentError, "Missing the required parameter 'generation_id' when calling ImageTargetApi.get_image_target_status"
      end
      # resource path
      local_var_path = '/targetCollection/{tcId}/generation/targets/{generationId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s)).sub('{' + 'generationId' + '}', CGI.escape(generation_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'CreateImageTargetsResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetApi.get_image_target_status",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetApi#get_image_target_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Image Targets
    # Request all Image Targets in a Target Collection.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :sortby Targets may be sorted by &#39;name&#39;, &#39;creDat&#39;, &#39;modDat&#39;, &#39;rating&#39;. Default value: &#39;creDat&#39;
    # @option opts [String] :sortorder Targets may be sorted ascending (&#39;asc&#39;) or descending (&#39;desc&#39;). Default value: &#39;desc&#39;
    # @option opts [Float] :skip Set 0 to start with first target, set e.g. to 2 to skip first 2 targets. Default value: 0
    # @option opts [Float] :limit Set to 0 for &#39;all targets&#39; or use positive value to define max. amount of targets to return. Default value: 0
    # @option opts [String] :s The search string to look for in target names.
    # @option opts [Boolean] :add_has_augmentations Add the hasAugmentations property.
    # @return [Array<ImageTargetResponse>]
    def get_image_targets(x_version, x_token, tc_id, opts = {})
      data, _status_code, _headers = get_image_targets_with_http_info(x_version, x_token, tc_id, opts)
      data
    end

    # Get Image Targets
    # Request all Image Targets in a Target Collection.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :sortby Targets may be sorted by &#39;name&#39;, &#39;creDat&#39;, &#39;modDat&#39;, &#39;rating&#39;. Default value: &#39;creDat&#39;
    # @option opts [String] :sortorder Targets may be sorted ascending (&#39;asc&#39;) or descending (&#39;desc&#39;). Default value: &#39;desc&#39;
    # @option opts [Float] :skip Set 0 to start with first target, set e.g. to 2 to skip first 2 targets. Default value: 0
    # @option opts [Float] :limit Set to 0 for &#39;all targets&#39; or use positive value to define max. amount of targets to return. Default value: 0
    # @option opts [String] :s The search string to look for in target names.
    # @option opts [Boolean] :add_has_augmentations Add the hasAugmentations property.
    # @return [Array<(Array<ImageTargetResponse>, Integer, Hash)>] Array<ImageTargetResponse> data, response status code and response headers
    def get_image_targets_with_http_info(x_version, x_token, tc_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetApi.get_image_targets ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetApi.get_image_targets"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetApi.get_image_targets"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ImageTargetApi.get_image_targets"
      end
      # resource path
      local_var_path = '/targetCollection/{tcId}/target'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'sortby'] = opts[:'sortby'] if !opts[:'sortby'].nil?
      query_params[:'sortorder'] = opts[:'sortorder'] if !opts[:'sortorder'].nil?
      query_params[:'skip'] = opts[:'skip'] if !opts[:'skip'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'s'] = opts[:'s'] if !opts[:'s'].nil?
      query_params[:'addHasAugmentations'] = opts[:'add_has_augmentations'] if !opts[:'add_has_augmentations'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<ImageTargetResponse>'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetApi.get_image_targets",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetApi#get_image_targets\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update Image Target
    # Updates properties of a particular Target in your account. Currently following properties are supported: physicalHeight, metadata. 
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param target_id [String] Unique identifier of the Image Target.
    # @param update_image_target_body [UpdateImageTargetBody] 
    # @param [Hash] opts the optional parameters
    # @return [ImageTargetResponse]
    def update_image_target(x_version, x_token, content_type, tc_id, target_id, update_image_target_body, opts = {})
      data, _status_code, _headers = update_image_target_with_http_info(x_version, x_token, content_type, tc_id, target_id, update_image_target_body, opts)
      data
    end

    # Update Image Target
    # Updates properties of a particular Target in your account. Currently following properties are supported: physicalHeight, metadata. 
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param target_id [String] Unique identifier of the Image Target.
    # @param update_image_target_body [UpdateImageTargetBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ImageTargetResponse, Integer, Hash)>] ImageTargetResponse data, response status code and response headers
    def update_image_target_with_http_info(x_version, x_token, content_type, tc_id, target_id, update_image_target_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetApi.update_image_target ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetApi.update_image_target"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetApi.update_image_target"
      end
      # verify the required parameter 'content_type' is set
      if @api_client.config.client_side_validation && content_type.nil?
        fail ArgumentError, "Missing the required parameter 'content_type' when calling ImageTargetApi.update_image_target"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ImageTargetApi.update_image_target"
      end
      # verify the required parameter 'target_id' is set
      if @api_client.config.client_side_validation && target_id.nil?
        fail ArgumentError, "Missing the required parameter 'target_id' when calling ImageTargetApi.update_image_target"
      end
      # verify the required parameter 'update_image_target_body' is set
      if @api_client.config.client_side_validation && update_image_target_body.nil?
        fail ArgumentError, "Missing the required parameter 'update_image_target_body' when calling ImageTargetApi.update_image_target"
      end
      # resource path
      local_var_path = '/targetCollection/{tcId}/target/{targetId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s)).sub('{' + 'targetId' + '}', CGI.escape(target_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token
      header_params[:'Content-Type'] = content_type

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(update_image_target_body)

      # return_type
      return_type = opts[:debug_return_type] || 'ImageTargetResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetApi.update_image_target",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetApi#update_image_target\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
