=begin
#Wikitude Studio API

#The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 

The version of the OpenAPI document: 3.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0

=end

require 'cgi'

module WikitudeStudioAPIClient
  class ImageTargetCollectionApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create Image Target Collection
    # Create a new target collection in your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param create_image_target_collection_body [CreateImageTargetCollectionBody] 
    # @param [Hash] opts the optional parameters
    # @return [ImageTargetCollectionResponse]
    def create_image_target_collection(x_version, x_token, content_type, create_image_target_collection_body, opts = {})
      data, _status_code, _headers = create_image_target_collection_with_http_info(x_version, x_token, content_type, create_image_target_collection_body, opts)
      data
    end

    # Create Image Target Collection
    # Create a new target collection in your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param create_image_target_collection_body [CreateImageTargetCollectionBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ImageTargetCollectionResponse, Integer, Hash)>] ImageTargetCollectionResponse data, response status code and response headers
    def create_image_target_collection_with_http_info(x_version, x_token, content_type, create_image_target_collection_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetCollectionApi.create_image_target_collection ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetCollectionApi.create_image_target_collection"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetCollectionApi.create_image_target_collection"
      end
      # verify the required parameter 'content_type' is set
      if @api_client.config.client_side_validation && content_type.nil?
        fail ArgumentError, "Missing the required parameter 'content_type' when calling ImageTargetCollectionApi.create_image_target_collection"
      end
      # verify the required parameter 'create_image_target_collection_body' is set
      if @api_client.config.client_side_validation && create_image_target_collection_body.nil?
        fail ArgumentError, "Missing the required parameter 'create_image_target_collection_body' when calling ImageTargetCollectionApi.create_image_target_collection"
      end
      # resource path
      local_var_path = '/targetCollection'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token
      header_params[:'Content-Type'] = content_type

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(create_image_target_collection_body)

      # return_type
      return_type = opts[:debug_return_type] || 'ImageTargetCollectionResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetCollectionApi.create_image_target_collection",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetCollectionApi#create_image_target_collection\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete Image Target Collection
    # Delete a particular target collection from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_image_target_collection(x_version, x_token, tc_id, opts = {})
      delete_image_target_collection_with_http_info(x_version, x_token, tc_id, opts)
      nil
    end

    # Delete Image Target Collection
    # Delete a particular target collection from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_image_target_collection_with_http_info(x_version, x_token, tc_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetCollectionApi.delete_image_target_collection ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetCollectionApi.delete_image_target_collection"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetCollectionApi.delete_image_target_collection"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ImageTargetCollectionApi.delete_image_target_collection"
      end
      # resource path
      local_var_path = '/targetCollection/{tcId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type]

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetCollectionApi.delete_image_target_collection",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetCollectionApi#delete_image_target_collection\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Generate Cloud Archive
    # DEPRECATED - Generate a Cloud Archive from an existing Target Collection. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate Cloud Archive). As of release 4.0.0 this endpoint will return error TARGET_COLLECTION_IS_UP_TO_DATE with status code 412, since the archive will be generated automatically in the background in the future. This endpoint is marked as \"deprecated\" since the behaviour will slightly change. However, this endpoint will still exist in version 3. 
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param [Hash] opts the optional parameters
    # @return [CloudArchiveGenerationResponse]
    def generate_cloud_archive(x_version, x_token, tc_id, opts = {})
      data, _status_code, _headers = generate_cloud_archive_with_http_info(x_version, x_token, tc_id, opts)
      data
    end

    # Generate Cloud Archive
    # DEPRECATED - Generate a Cloud Archive from an existing Target Collection. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate Cloud Archive). As of release 4.0.0 this endpoint will return error TARGET_COLLECTION_IS_UP_TO_DATE with status code 412, since the archive will be generated automatically in the background in the future. This endpoint is marked as \&quot;deprecated\&quot; since the behaviour will slightly change. However, this endpoint will still exist in version 3. 
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param [Hash] opts the optional parameters
    # @return [Array<(CloudArchiveGenerationResponse, Integer, Hash)>] CloudArchiveGenerationResponse data, response status code and response headers
    def generate_cloud_archive_with_http_info(x_version, x_token, tc_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetCollectionApi.generate_cloud_archive ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetCollectionApi.generate_cloud_archive"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetCollectionApi.generate_cloud_archive"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ImageTargetCollectionApi.generate_cloud_archive"
      end
      # resource path
      local_var_path = '/targetCollection/{tcId}/generation/cloudarchive'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'CloudArchiveGenerationResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetCollectionApi.generate_cloud_archive",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetCollectionApi#generate_cloud_archive\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Generate WTC
    # Generates a WTC file out of an existing Target Collection with up to 1000 targets. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate WTC). 
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param generate_wtc_body [GenerateWTCBody] 
    # @param [Hash] opts the optional parameters
    # @return [GenerateWTCStatusResponse]
    def generate_wtc(x_version, x_token, content_type, tc_id, generate_wtc_body, opts = {})
      data, _status_code, _headers = generate_wtc_with_http_info(x_version, x_token, content_type, tc_id, generate_wtc_body, opts)
      data
    end

    # Generate WTC
    # Generates a WTC file out of an existing Target Collection with up to 1000 targets. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate WTC). 
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param generate_wtc_body [GenerateWTCBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(GenerateWTCStatusResponse, Integer, Hash)>] GenerateWTCStatusResponse data, response status code and response headers
    def generate_wtc_with_http_info(x_version, x_token, content_type, tc_id, generate_wtc_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetCollectionApi.generate_wtc ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetCollectionApi.generate_wtc"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetCollectionApi.generate_wtc"
      end
      # verify the required parameter 'content_type' is set
      if @api_client.config.client_side_validation && content_type.nil?
        fail ArgumentError, "Missing the required parameter 'content_type' when calling ImageTargetCollectionApi.generate_wtc"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ImageTargetCollectionApi.generate_wtc"
      end
      # verify the required parameter 'generate_wtc_body' is set
      if @api_client.config.client_side_validation && generate_wtc_body.nil?
        fail ArgumentError, "Missing the required parameter 'generate_wtc_body' when calling ImageTargetCollectionApi.generate_wtc"
      end
      # resource path
      local_var_path = '/targetCollection/{tcId}/generation/wtc'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token
      header_params[:'Content-Type'] = content_type

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(generate_wtc_body)

      # return_type
      return_type = opts[:debug_return_type] || 'GenerateWTCStatusResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetCollectionApi.generate_wtc",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetCollectionApi#generate_wtc\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Status - Generate Cloud Archive
    # Retrieves information status about a particular scheduled cloud archive generation.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param generation_id [String] Unique identifier of the asynchronous job created by a generation endpoint.
    # @param [Hash] opts the optional parameters
    # @return [CloudArchiveGenerationResponse]
    def get_cloud_archive_status(x_version, x_token, tc_id, generation_id, opts = {})
      data, _status_code, _headers = get_cloud_archive_status_with_http_info(x_version, x_token, tc_id, generation_id, opts)
      data
    end

    # Status - Generate Cloud Archive
    # Retrieves information status about a particular scheduled cloud archive generation.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param generation_id [String] Unique identifier of the asynchronous job created by a generation endpoint.
    # @param [Hash] opts the optional parameters
    # @return [Array<(CloudArchiveGenerationResponse, Integer, Hash)>] CloudArchiveGenerationResponse data, response status code and response headers
    def get_cloud_archive_status_with_http_info(x_version, x_token, tc_id, generation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetCollectionApi.get_cloud_archive_status ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetCollectionApi.get_cloud_archive_status"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetCollectionApi.get_cloud_archive_status"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ImageTargetCollectionApi.get_cloud_archive_status"
      end
      # verify the required parameter 'generation_id' is set
      if @api_client.config.client_side_validation && generation_id.nil?
        fail ArgumentError, "Missing the required parameter 'generation_id' when calling ImageTargetCollectionApi.get_cloud_archive_status"
      end
      # resource path
      local_var_path = '/targetCollection/{tcId}/generation/cloudarchive/{generationId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s)).sub('{' + 'generationId' + '}', CGI.escape(generation_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'CloudArchiveGenerationResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetCollectionApi.get_cloud_archive_status",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetCollectionApi#get_cloud_archive_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Image Target Collection
    # Request a particular target collection from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param [Hash] opts the optional parameters
    # @return [ImageTargetCollectionResponse]
    def get_image_target_collection(x_version, x_token, tc_id, opts = {})
      data, _status_code, _headers = get_image_target_collection_with_http_info(x_version, x_token, tc_id, opts)
      data
    end

    # Get Image Target Collection
    # Request a particular target collection from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param [Hash] opts the optional parameters
    # @return [Array<(ImageTargetCollectionResponse, Integer, Hash)>] ImageTargetCollectionResponse data, response status code and response headers
    def get_image_target_collection_with_http_info(x_version, x_token, tc_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetCollectionApi.get_image_target_collection ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetCollectionApi.get_image_target_collection"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetCollectionApi.get_image_target_collection"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ImageTargetCollectionApi.get_image_target_collection"
      end
      # resource path
      local_var_path = '/targetCollection/{tcId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'ImageTargetCollectionResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetCollectionApi.get_image_target_collection",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetCollectionApi#get_image_target_collection\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get all Image Target Collections
    # Request all target collections from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0
    # @option opts [Integer] :limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000
    # @return [Array<ImageTargetCollectionResponse>]
    def get_image_target_collections(x_version, x_token, opts = {})
      data, _status_code, _headers = get_image_target_collections_with_http_info(x_version, x_token, opts)
      data
    end

    # Get all Image Target Collections
    # Request all target collections from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0
    # @option opts [Integer] :limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000
    # @return [Array<(Array<ImageTargetCollectionResponse>, Integer, Hash)>] Array<ImageTargetCollectionResponse> data, response status code and response headers
    def get_image_target_collections_with_http_info(x_version, x_token, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetCollectionApi.get_image_target_collections ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetCollectionApi.get_image_target_collections"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetCollectionApi.get_image_target_collections"
      end
      # resource path
      local_var_path = '/targetCollection'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'skip'] = opts[:'skip'] if !opts[:'skip'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<ImageTargetCollectionResponse>'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetCollectionApi.get_image_target_collections",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetCollectionApi#get_image_target_collections\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Status - Similarity Check
    # Retrieves information status of a particular scheduled \"Similarity Check\".
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param generation_id [String] Unique identifier of the asynchronous job created by a generation endpoint.
    # @param [Hash] opts the optional parameters
    # @return [SimilarityCheckStatusResponse]
    def get_similarity_check_status(x_version, x_token, tc_id, generation_id, opts = {})
      data, _status_code, _headers = get_similarity_check_status_with_http_info(x_version, x_token, tc_id, generation_id, opts)
      data
    end

    # Status - Similarity Check
    # Retrieves information status of a particular scheduled \&quot;Similarity Check\&quot;.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param generation_id [String] Unique identifier of the asynchronous job created by a generation endpoint.
    # @param [Hash] opts the optional parameters
    # @return [Array<(SimilarityCheckStatusResponse, Integer, Hash)>] SimilarityCheckStatusResponse data, response status code and response headers
    def get_similarity_check_status_with_http_info(x_version, x_token, tc_id, generation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetCollectionApi.get_similarity_check_status ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetCollectionApi.get_similarity_check_status"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetCollectionApi.get_similarity_check_status"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ImageTargetCollectionApi.get_similarity_check_status"
      end
      # verify the required parameter 'generation_id' is set
      if @api_client.config.client_side_validation && generation_id.nil?
        fail ArgumentError, "Missing the required parameter 'generation_id' when calling ImageTargetCollectionApi.get_similarity_check_status"
      end
      # resource path
      local_var_path = '/targetCollection/{tcId}/similarity/{generationId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s)).sub('{' + 'generationId' + '}', CGI.escape(generation_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'SimilarityCheckStatusResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetCollectionApi.get_similarity_check_status",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetCollectionApi#get_similarity_check_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Status - Generate WTC
    # Retrieves information status about a particular scheduled WTC file generation. Once the status is completed, the WTC information can be retrieved from the Target Collection (see Get Target Collection). 
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param generation_id [String] Unique identifier of the asynchronous job created by a generation endpoint.
    # @param [Hash] opts the optional parameters
    # @return [GenerateWTCStatusResponse]
    def get_wtc_status(x_version, x_token, tc_id, generation_id, opts = {})
      data, _status_code, _headers = get_wtc_status_with_http_info(x_version, x_token, tc_id, generation_id, opts)
      data
    end

    # Status - Generate WTC
    # Retrieves information status about a particular scheduled WTC file generation. Once the status is completed, the WTC information can be retrieved from the Target Collection (see Get Target Collection). 
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param generation_id [String] Unique identifier of the asynchronous job created by a generation endpoint.
    # @param [Hash] opts the optional parameters
    # @return [Array<(GenerateWTCStatusResponse, Integer, Hash)>] GenerateWTCStatusResponse data, response status code and response headers
    def get_wtc_status_with_http_info(x_version, x_token, tc_id, generation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetCollectionApi.get_wtc_status ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetCollectionApi.get_wtc_status"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetCollectionApi.get_wtc_status"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ImageTargetCollectionApi.get_wtc_status"
      end
      # verify the required parameter 'generation_id' is set
      if @api_client.config.client_side_validation && generation_id.nil?
        fail ArgumentError, "Missing the required parameter 'generation_id' when calling ImageTargetCollectionApi.get_wtc_status"
      end
      # resource path
      local_var_path = '/targetCollection/{tcId}/generation/wtc/{generationId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s)).sub('{' + 'generationId' + '}', CGI.escape(generation_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'GenerateWTCStatusResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetCollectionApi.get_wtc_status",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetCollectionApi#get_wtc_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Similarity Check
    # Pass up to 10 items pointing to PNG or JPEG images hosted via https in the body. In order to find out whether an image is similar to an existing Target in terms of recognition and tracking behaviour a check is performed per passed image item. The Target Collection must be published and have an active Cloud Archive in place. Up to 5 (default: 1) so called \"candidates\" with a similarity \"score\" are returned per image. Image must be hosted via https and be of type PNG or JPEG. Use \"maxCandidates\" to define the maximum amount of candidates to return for an image. Response header value \"Location\" directly points to the right \"Status - Similarity Check\" endpoint. Best practice is to trigger \"Similarity Check\", wait for \"estimatedLatency\" milliseconds and poll \"Status - Similarity Check\" endpoint every 5 seconds until its \"status\" is \"COMPLETED\". 
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param similarity_check_body [SimilarityCheckBody] 
    # @param [Hash] opts the optional parameters
    # @return [SimilarityCheckResponse]
    def similarity_check(x_version, x_token, content_type, tc_id, similarity_check_body, opts = {})
      data, _status_code, _headers = similarity_check_with_http_info(x_version, x_token, content_type, tc_id, similarity_check_body, opts)
      data
    end

    # Similarity Check
    # Pass up to 10 items pointing to PNG or JPEG images hosted via https in the body. In order to find out whether an image is similar to an existing Target in terms of recognition and tracking behaviour a check is performed per passed image item. The Target Collection must be published and have an active Cloud Archive in place. Up to 5 (default: 1) so called \&quot;candidates\&quot; with a similarity \&quot;score\&quot; are returned per image. Image must be hosted via https and be of type PNG or JPEG. Use \&quot;maxCandidates\&quot; to define the maximum amount of candidates to return for an image. Response header value \&quot;Location\&quot; directly points to the right \&quot;Status - Similarity Check\&quot; endpoint. Best practice is to trigger \&quot;Similarity Check\&quot;, wait for \&quot;estimatedLatency\&quot; milliseconds and poll \&quot;Status - Similarity Check\&quot; endpoint every 5 seconds until its \&quot;status\&quot; is \&quot;COMPLETED\&quot;. 
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param similarity_check_body [SimilarityCheckBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(SimilarityCheckResponse, Integer, Hash)>] SimilarityCheckResponse data, response status code and response headers
    def similarity_check_with_http_info(x_version, x_token, content_type, tc_id, similarity_check_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetCollectionApi.similarity_check ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetCollectionApi.similarity_check"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetCollectionApi.similarity_check"
      end
      # verify the required parameter 'content_type' is set
      if @api_client.config.client_side_validation && content_type.nil?
        fail ArgumentError, "Missing the required parameter 'content_type' when calling ImageTargetCollectionApi.similarity_check"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ImageTargetCollectionApi.similarity_check"
      end
      # verify the required parameter 'similarity_check_body' is set
      if @api_client.config.client_side_validation && similarity_check_body.nil?
        fail ArgumentError, "Missing the required parameter 'similarity_check_body' when calling ImageTargetCollectionApi.similarity_check"
      end
      # resource path
      local_var_path = '/targetCollection/{tcId}/similarity'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token
      header_params[:'Content-Type'] = content_type

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(similarity_check_body)

      # return_type
      return_type = opts[:debug_return_type] || 'SimilarityCheckResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetCollectionApi.similarity_check",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetCollectionApi#similarity_check\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update Image Target Collection
    # Update a target collection from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param update_image_target_collection_body [UpdateImageTargetCollectionBody] 
    # @param [Hash] opts the optional parameters
    # @return [ImageTargetCollectionResponse]
    def update_image_target_collection(x_version, x_token, content_type, tc_id, update_image_target_collection_body, opts = {})
      data, _status_code, _headers = update_image_target_collection_with_http_info(x_version, x_token, content_type, tc_id, update_image_target_collection_body, opts)
      data
    end

    # Update Image Target Collection
    # Update a target collection from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Image Target Collection.
    # @param update_image_target_collection_body [UpdateImageTargetCollectionBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ImageTargetCollectionResponse, Integer, Hash)>] ImageTargetCollectionResponse data, response status code and response headers
    def update_image_target_collection_with_http_info(x_version, x_token, content_type, tc_id, update_image_target_collection_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImageTargetCollectionApi.update_image_target_collection ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ImageTargetCollectionApi.update_image_target_collection"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ImageTargetCollectionApi.update_image_target_collection"
      end
      # verify the required parameter 'content_type' is set
      if @api_client.config.client_side_validation && content_type.nil?
        fail ArgumentError, "Missing the required parameter 'content_type' when calling ImageTargetCollectionApi.update_image_target_collection"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ImageTargetCollectionApi.update_image_target_collection"
      end
      # verify the required parameter 'update_image_target_collection_body' is set
      if @api_client.config.client_side_validation && update_image_target_collection_body.nil?
        fail ArgumentError, "Missing the required parameter 'update_image_target_collection_body' when calling ImageTargetCollectionApi.update_image_target_collection"
      end
      # resource path
      local_var_path = '/targetCollection/{tcId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token
      header_params[:'Content-Type'] = content_type

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(update_image_target_collection_body)

      # return_type
      return_type = opts[:debug_return_type] || 'ImageTargetCollectionResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ImageTargetCollectionApi.update_image_target_collection",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImageTargetCollectionApi#update_image_target_collection\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
