=begin
#Wikitude Studio API

#The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 

The version of the OpenAPI document: 3.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0

=end

require 'cgi'

module WikitudeStudioAPIClient
  class ObjectTargetApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create Object Target from Images
    # Create a new Object Target in an Object Target Collection from at least two Image files.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param create_object_target_images_body [CreateObjectTargetImagesBody] 
    # @param [Hash] opts the optional parameters
    # @return [ObjectTargetJobResponse]
    def create_object_target_from_images(x_version, x_token, content_type, tc_id, create_object_target_images_body, opts = {})
      data, _status_code, _headers = create_object_target_from_images_with_http_info(x_version, x_token, content_type, tc_id, create_object_target_images_body, opts)
      data
    end

    # Create Object Target from Images
    # Create a new Object Target in an Object Target Collection from at least two Image files.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param create_object_target_images_body [CreateObjectTargetImagesBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ObjectTargetJobResponse, Integer, Hash)>] ObjectTargetJobResponse data, response status code and response headers
    def create_object_target_from_images_with_http_info(x_version, x_token, content_type, tc_id, create_object_target_images_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetApi.create_object_target_from_images ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetApi.create_object_target_from_images"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetApi.create_object_target_from_images"
      end
      # verify the required parameter 'content_type' is set
      if @api_client.config.client_side_validation && content_type.nil?
        fail ArgumentError, "Missing the required parameter 'content_type' when calling ObjectTargetApi.create_object_target_from_images"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ObjectTargetApi.create_object_target_from_images"
      end
      # verify the required parameter 'create_object_target_images_body' is set
      if @api_client.config.client_side_validation && create_object_target_images_body.nil?
        fail ArgumentError, "Missing the required parameter 'create_object_target_images_body' when calling ObjectTargetApi.create_object_target_from_images"
      end
      # resource path
      local_var_path = '/objectTargetCollection/{tcId}/target/images'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token
      header_params[:'Content-Type'] = content_type

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(create_object_target_images_body)

      # return_type
      return_type = opts[:debug_return_type] || 'ObjectTargetJobResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetApi.create_object_target_from_images",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetApi#create_object_target_from_images\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create Object Target from WTO
    # Create a new Object Target in an Object Target Collection from a WTO file.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param create_object_target_wto_body [CreateObjectTargetWTOBody] 
    # @param [Hash] opts the optional parameters
    # @return [ObjectTargetJobResponse]
    def create_object_target_from_wto(x_version, x_token, content_type, tc_id, create_object_target_wto_body, opts = {})
      data, _status_code, _headers = create_object_target_from_wto_with_http_info(x_version, x_token, content_type, tc_id, create_object_target_wto_body, opts)
      data
    end

    # Create Object Target from WTO
    # Create a new Object Target in an Object Target Collection from a WTO file.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param create_object_target_wto_body [CreateObjectTargetWTOBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ObjectTargetJobResponse, Integer, Hash)>] ObjectTargetJobResponse data, response status code and response headers
    def create_object_target_from_wto_with_http_info(x_version, x_token, content_type, tc_id, create_object_target_wto_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetApi.create_object_target_from_wto ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetApi.create_object_target_from_wto"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetApi.create_object_target_from_wto"
      end
      # verify the required parameter 'content_type' is set
      if @api_client.config.client_side_validation && content_type.nil?
        fail ArgumentError, "Missing the required parameter 'content_type' when calling ObjectTargetApi.create_object_target_from_wto"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ObjectTargetApi.create_object_target_from_wto"
      end
      # verify the required parameter 'create_object_target_wto_body' is set
      if @api_client.config.client_side_validation && create_object_target_wto_body.nil?
        fail ArgumentError, "Missing the required parameter 'create_object_target_wto_body' when calling ObjectTargetApi.create_object_target_from_wto"
      end
      # resource path
      local_var_path = '/objectTargetCollection/{tcId}/target/wto'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token
      header_params[:'Content-Type'] = content_type

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(create_object_target_wto_body)

      # return_type
      return_type = opts[:debug_return_type] || 'ObjectTargetJobResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetApi.create_object_target_from_wto",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetApi#create_object_target_from_wto\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete Object Target
    # Delete a particular Object Target from your Object Target Collection.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param target_id [String] Unique identifier of the Object Target.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_object_target(x_version, x_token, tc_id, target_id, opts = {})
      delete_object_target_with_http_info(x_version, x_token, tc_id, target_id, opts)
      nil
    end

    # Delete Object Target
    # Delete a particular Object Target from your Object Target Collection.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param target_id [String] Unique identifier of the Object Target.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_object_target_with_http_info(x_version, x_token, tc_id, target_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetApi.delete_object_target ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetApi.delete_object_target"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetApi.delete_object_target"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ObjectTargetApi.delete_object_target"
      end
      # verify the required parameter 'target_id' is set
      if @api_client.config.client_side_validation && target_id.nil?
        fail ArgumentError, "Missing the required parameter 'target_id' when calling ObjectTargetApi.delete_object_target"
      end
      # resource path
      local_var_path = '/objectTargetCollection/{tcId}/target/{targetId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s)).sub('{' + 'targetId' + '}', CGI.escape(target_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type]

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetApi.delete_object_target",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetApi#delete_object_target\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Extend Object Target
    # Add source images to an existing target.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param target_id [String] Unique identifier of the Object Target.
    # @param extend_object_target_body [ExtendObjectTargetBody] 
    # @param [Hash] opts the optional parameters
    # @return [ObjectTargetJobResponse]
    def extend_object_target(x_version, x_token, content_type, tc_id, target_id, extend_object_target_body, opts = {})
      data, _status_code, _headers = extend_object_target_with_http_info(x_version, x_token, content_type, tc_id, target_id, extend_object_target_body, opts)
      data
    end

    # Extend Object Target
    # Add source images to an existing target.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param target_id [String] Unique identifier of the Object Target.
    # @param extend_object_target_body [ExtendObjectTargetBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ObjectTargetJobResponse, Integer, Hash)>] ObjectTargetJobResponse data, response status code and response headers
    def extend_object_target_with_http_info(x_version, x_token, content_type, tc_id, target_id, extend_object_target_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetApi.extend_object_target ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetApi.extend_object_target"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetApi.extend_object_target"
      end
      # verify the required parameter 'content_type' is set
      if @api_client.config.client_side_validation && content_type.nil?
        fail ArgumentError, "Missing the required parameter 'content_type' when calling ObjectTargetApi.extend_object_target"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ObjectTargetApi.extend_object_target"
      end
      # verify the required parameter 'target_id' is set
      if @api_client.config.client_side_validation && target_id.nil?
        fail ArgumentError, "Missing the required parameter 'target_id' when calling ObjectTargetApi.extend_object_target"
      end
      # verify the required parameter 'extend_object_target_body' is set
      if @api_client.config.client_side_validation && extend_object_target_body.nil?
        fail ArgumentError, "Missing the required parameter 'extend_object_target_body' when calling ObjectTargetApi.extend_object_target"
      end
      # resource path
      local_var_path = '/objectTargetCollection/{tcId}/target/{targetId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s)).sub('{' + 'targetId' + '}', CGI.escape(target_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token
      header_params[:'Content-Type'] = content_type

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(extend_object_target_body)

      # return_type
      return_type = opts[:debug_return_type] || 'ObjectTargetJobResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetApi.extend_object_target",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetApi#extend_object_target\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Object Target
    # Request a specific Object Targets from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param target_id [String] Unique identifier of the Object Target.
    # @param [Hash] opts the optional parameters
    # @return [ObjectTargetResponse]
    def get_object_target(x_version, x_token, tc_id, target_id, opts = {})
      data, _status_code, _headers = get_object_target_with_http_info(x_version, x_token, tc_id, target_id, opts)
      data
    end

    # Get Object Target
    # Request a specific Object Targets from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param target_id [String] Unique identifier of the Object Target.
    # @param [Hash] opts the optional parameters
    # @return [Array<(ObjectTargetResponse, Integer, Hash)>] ObjectTargetResponse data, response status code and response headers
    def get_object_target_with_http_info(x_version, x_token, tc_id, target_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetApi.get_object_target ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetApi.get_object_target"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetApi.get_object_target"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ObjectTargetApi.get_object_target"
      end
      # verify the required parameter 'target_id' is set
      if @api_client.config.client_side_validation && target_id.nil?
        fail ArgumentError, "Missing the required parameter 'target_id' when calling ObjectTargetApi.get_object_target"
      end
      # resource path
      local_var_path = '/objectTargetCollection/{tcId}/target/{targetId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s)).sub('{' + 'targetId' + '}', CGI.escape(target_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'ObjectTargetResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetApi.get_object_target",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetApi#get_object_target\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Status - Object Target Generation Information
    # Retrieves information status about a particular scheduled Object Target creation.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param generation_id [String] Unique identifier of the asynchronous job created by a generation endpoint.
    # @param [Hash] opts the optional parameters
    # @return [ObjectTargetJobResponse]
    def get_object_target_status(x_version, x_token, tc_id, generation_id, opts = {})
      data, _status_code, _headers = get_object_target_status_with_http_info(x_version, x_token, tc_id, generation_id, opts)
      data
    end

    # Status - Object Target Generation Information
    # Retrieves information status about a particular scheduled Object Target creation.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param generation_id [String] Unique identifier of the asynchronous job created by a generation endpoint.
    # @param [Hash] opts the optional parameters
    # @return [Array<(ObjectTargetJobResponse, Integer, Hash)>] ObjectTargetJobResponse data, response status code and response headers
    def get_object_target_status_with_http_info(x_version, x_token, tc_id, generation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetApi.get_object_target_status ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetApi.get_object_target_status"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetApi.get_object_target_status"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ObjectTargetApi.get_object_target_status"
      end
      # verify the required parameter 'generation_id' is set
      if @api_client.config.client_side_validation && generation_id.nil?
        fail ArgumentError, "Missing the required parameter 'generation_id' when calling ObjectTargetApi.get_object_target_status"
      end
      # resource path
      local_var_path = '/objectTargetCollection/{tcId}/generation/targets/{generationId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s)).sub('{' + 'generationId' + '}', CGI.escape(generation_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'ObjectTargetJobResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetApi.get_object_target_status",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetApi#get_object_target_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Object Targets
    # Request all Object Targets in a Target Collection.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param [Hash] opts the optional parameters
    # @return [Array<ObjectTargetResponse>]
    def get_object_targets(x_version, x_token, tc_id, opts = {})
      data, _status_code, _headers = get_object_targets_with_http_info(x_version, x_token, tc_id, opts)
      data
    end

    # Get Object Targets
    # Request all Object Targets in a Target Collection.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<ObjectTargetResponse>, Integer, Hash)>] Array<ObjectTargetResponse> data, response status code and response headers
    def get_object_targets_with_http_info(x_version, x_token, tc_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetApi.get_object_targets ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetApi.get_object_targets"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetApi.get_object_targets"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ObjectTargetApi.get_object_targets"
      end
      # resource path
      local_var_path = '/objectTargetCollection/{tcId}/target'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<ObjectTargetResponse>'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetApi.get_object_targets",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetApi#get_object_targets\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Rename Object Target
    # Rename an existing target.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param target_id [String] Unique identifier of the Object Target.
    # @param rename_object_target_body [RenameObjectTargetBody] 
    # @param [Hash] opts the optional parameters
    # @return [ObjectTargetJobResponse]
    def rename_object_target(x_version, x_token, content_type, tc_id, target_id, rename_object_target_body, opts = {})
      data, _status_code, _headers = rename_object_target_with_http_info(x_version, x_token, content_type, tc_id, target_id, rename_object_target_body, opts)
      data
    end

    # Rename Object Target
    # Rename an existing target.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param target_id [String] Unique identifier of the Object Target.
    # @param rename_object_target_body [RenameObjectTargetBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ObjectTargetJobResponse, Integer, Hash)>] ObjectTargetJobResponse data, response status code and response headers
    def rename_object_target_with_http_info(x_version, x_token, content_type, tc_id, target_id, rename_object_target_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetApi.rename_object_target ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetApi.rename_object_target"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetApi.rename_object_target"
      end
      # verify the required parameter 'content_type' is set
      if @api_client.config.client_side_validation && content_type.nil?
        fail ArgumentError, "Missing the required parameter 'content_type' when calling ObjectTargetApi.rename_object_target"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ObjectTargetApi.rename_object_target"
      end
      # verify the required parameter 'target_id' is set
      if @api_client.config.client_side_validation && target_id.nil?
        fail ArgumentError, "Missing the required parameter 'target_id' when calling ObjectTargetApi.rename_object_target"
      end
      # verify the required parameter 'rename_object_target_body' is set
      if @api_client.config.client_side_validation && rename_object_target_body.nil?
        fail ArgumentError, "Missing the required parameter 'rename_object_target_body' when calling ObjectTargetApi.rename_object_target"
      end
      # resource path
      local_var_path = '/objectTargetCollection/{tcId}/target/{targetId}/name'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s)).sub('{' + 'targetId' + '}', CGI.escape(target_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token
      header_params[:'Content-Type'] = content_type

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(rename_object_target_body)

      # return_type
      return_type = opts[:debug_return_type] || 'ObjectTargetJobResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetApi.rename_object_target",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetApi#rename_object_target\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
