=begin
#Wikitude Studio API

#The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 

The version of the OpenAPI document: 3.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0

=end

require 'cgi'

module WikitudeStudioAPIClient
  class ObjectTargetCollectionApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create Object Target Collection
    # Create a new Object Target Collection in your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param create_object_target_collection_body [CreateObjectTargetCollectionBody] 
    # @param [Hash] opts the optional parameters
    # @return [ObjectTargetCollectionResponse]
    def create_object_target_collection(x_version, x_token, content_type, create_object_target_collection_body, opts = {})
      data, _status_code, _headers = create_object_target_collection_with_http_info(x_version, x_token, content_type, create_object_target_collection_body, opts)
      data
    end

    # Create Object Target Collection
    # Create a new Object Target Collection in your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param create_object_target_collection_body [CreateObjectTargetCollectionBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ObjectTargetCollectionResponse, Integer, Hash)>] ObjectTargetCollectionResponse data, response status code and response headers
    def create_object_target_collection_with_http_info(x_version, x_token, content_type, create_object_target_collection_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetCollectionApi.create_object_target_collection ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetCollectionApi.create_object_target_collection"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetCollectionApi.create_object_target_collection"
      end
      # verify the required parameter 'content_type' is set
      if @api_client.config.client_side_validation && content_type.nil?
        fail ArgumentError, "Missing the required parameter 'content_type' when calling ObjectTargetCollectionApi.create_object_target_collection"
      end
      # verify the required parameter 'create_object_target_collection_body' is set
      if @api_client.config.client_side_validation && create_object_target_collection_body.nil?
        fail ArgumentError, "Missing the required parameter 'create_object_target_collection_body' when calling ObjectTargetCollectionApi.create_object_target_collection"
      end
      # resource path
      local_var_path = '/objectTargetCollection'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token
      header_params[:'Content-Type'] = content_type

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(create_object_target_collection_body)

      # return_type
      return_type = opts[:debug_return_type] || 'ObjectTargetCollectionResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetCollectionApi.create_object_target_collection",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetCollectionApi#create_object_target_collection\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete Object Target Collection
    # Delete a Object Target Collection and all its Object Targets.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_object_target_collection(x_version, x_token, tc_id, opts = {})
      delete_object_target_collection_with_http_info(x_version, x_token, tc_id, opts)
      nil
    end

    # Delete Object Target Collection
    # Delete a Object Target Collection and all its Object Targets.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_object_target_collection_with_http_info(x_version, x_token, tc_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetCollectionApi.delete_object_target_collection ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetCollectionApi.delete_object_target_collection"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetCollectionApi.delete_object_target_collection"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ObjectTargetCollectionApi.delete_object_target_collection"
      end
      # resource path
      local_var_path = '/objectTargetCollection/{tcId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type]

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetCollectionApi.delete_object_target_collection",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetCollectionApi#delete_object_target_collection\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Generate WTO
    # Generate a WTO file containing the Object Target Collection and all its Object Targets.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param generate_wto_body [GenerateWTOBody] 
    # @param [Hash] opts the optional parameters
    # @return [ObjectTargetCollectionJobResponse]
    def generate_wto(x_version, x_token, content_type, tc_id, generate_wto_body, opts = {})
      data, _status_code, _headers = generate_wto_with_http_info(x_version, x_token, content_type, tc_id, generate_wto_body, opts)
      data
    end

    # Generate WTO
    # Generate a WTO file containing the Object Target Collection and all its Object Targets.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param generate_wto_body [GenerateWTOBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ObjectTargetCollectionJobResponse, Integer, Hash)>] ObjectTargetCollectionJobResponse data, response status code and response headers
    def generate_wto_with_http_info(x_version, x_token, content_type, tc_id, generate_wto_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetCollectionApi.generate_wto ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetCollectionApi.generate_wto"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetCollectionApi.generate_wto"
      end
      # verify the required parameter 'content_type' is set
      if @api_client.config.client_side_validation && content_type.nil?
        fail ArgumentError, "Missing the required parameter 'content_type' when calling ObjectTargetCollectionApi.generate_wto"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ObjectTargetCollectionApi.generate_wto"
      end
      # verify the required parameter 'generate_wto_body' is set
      if @api_client.config.client_side_validation && generate_wto_body.nil?
        fail ArgumentError, "Missing the required parameter 'generate_wto_body' when calling ObjectTargetCollectionApi.generate_wto"
      end
      # resource path
      local_var_path = '/objectTargetCollection/{tcId}/generation/wto'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token
      header_params[:'Content-Type'] = content_type

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(generate_wto_body)

      # return_type
      return_type = opts[:debug_return_type] || 'ObjectTargetCollectionJobResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetCollectionApi.generate_wto",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetCollectionApi#generate_wto\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get Object Target Collection
    # Request a particular Object Target Collection from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param [Hash] opts the optional parameters
    # @return [ObjectTargetCollectionResponse]
    def get_object_target_collection(x_version, x_token, tc_id, opts = {})
      data, _status_code, _headers = get_object_target_collection_with_http_info(x_version, x_token, tc_id, opts)
      data
    end

    # Get Object Target Collection
    # Request a particular Object Target Collection from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param [Hash] opts the optional parameters
    # @return [Array<(ObjectTargetCollectionResponse, Integer, Hash)>] ObjectTargetCollectionResponse data, response status code and response headers
    def get_object_target_collection_with_http_info(x_version, x_token, tc_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetCollectionApi.get_object_target_collection ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetCollectionApi.get_object_target_collection"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetCollectionApi.get_object_target_collection"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ObjectTargetCollectionApi.get_object_target_collection"
      end
      # resource path
      local_var_path = '/objectTargetCollection/{tcId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'ObjectTargetCollectionResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetCollectionApi.get_object_target_collection",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetCollectionApi#get_object_target_collection\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Status - Get Object Target Collection jobs
    # Retrieves a list of asynchronous jobs sorted by creation date.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :skip Set 0 to start with first collection, set e.g. to 2 to skip first 2 collections. Default value: 0
    # @option opts [Integer] :limit Use positive value to define the amount of entries to return [1, 20] per page. Default value: 10
    # @option opts [String] :source filter the jobs by source. Available values (api, studio). Default value: api
    # @option opts [String] :type filter the jobs by type.
    # @return [Array<ObjectTargetJobResponse>]
    def get_object_target_collection_status(x_version, x_token, tc_id, opts = {})
      data, _status_code, _headers = get_object_target_collection_status_with_http_info(x_version, x_token, tc_id, opts)
      data
    end

    # Status - Get Object Target Collection jobs
    # Retrieves a list of asynchronous jobs sorted by creation date.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :skip Set 0 to start with first collection, set e.g. to 2 to skip first 2 collections. Default value: 0
    # @option opts [Integer] :limit Use positive value to define the amount of entries to return [1, 20] per page. Default value: 10
    # @option opts [String] :source filter the jobs by source. Available values (api, studio). Default value: api
    # @option opts [String] :type filter the jobs by type.
    # @return [Array<(Array<ObjectTargetJobResponse>, Integer, Hash)>] Array<ObjectTargetJobResponse> data, response status code and response headers
    def get_object_target_collection_status_with_http_info(x_version, x_token, tc_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetCollectionApi.get_object_target_collection_status ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetCollectionApi.get_object_target_collection_status"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetCollectionApi.get_object_target_collection_status"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ObjectTargetCollectionApi.get_object_target_collection_status"
      end
      # resource path
      local_var_path = '/objectTargetCollection/{tcId}/jobs'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'skip'] = opts[:'skip'] if !opts[:'skip'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'source'] = opts[:'source'] if !opts[:'source'].nil?
      query_params[:'type'] = opts[:'type'] if !opts[:'type'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<ObjectTargetJobResponse>'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetCollectionApi.get_object_target_collection_status",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetCollectionApi#get_object_target_collection_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Get all Object Target Collections
    # Request all Object Target Collections from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0
    # @option opts [Integer] :limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000
    # @return [Array<ObjectTargetCollectionResponse>]
    def get_object_target_collections(x_version, x_token, opts = {})
      data, _status_code, _headers = get_object_target_collections_with_http_info(x_version, x_token, opts)
      data
    end

    # Get all Object Target Collections
    # Request all Object Target Collections from your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0
    # @option opts [Integer] :limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000
    # @return [Array<(Array<ObjectTargetCollectionResponse>, Integer, Hash)>] Array<ObjectTargetCollectionResponse> data, response status code and response headers
    def get_object_target_collections_with_http_info(x_version, x_token, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetCollectionApi.get_object_target_collections ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetCollectionApi.get_object_target_collections"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetCollectionApi.get_object_target_collections"
      end
      # resource path
      local_var_path = '/objectTargetCollection'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'skip'] = opts[:'skip'] if !opts[:'skip'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'Array<ObjectTargetCollectionResponse>'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetCollectionApi.get_object_target_collections",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetCollectionApi#get_object_target_collections\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Status - Generate WTO
    # Retrieves information status about a particular scheduled wto generation.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param generation_id [String] Unique identifier of the asynchronous job created by a generation endpoint.
    # @param [Hash] opts the optional parameters
    # @return [ObjectTargetCollectionJobResponse]
    def get_wto_status(x_version, x_token, tc_id, generation_id, opts = {})
      data, _status_code, _headers = get_wto_status_with_http_info(x_version, x_token, tc_id, generation_id, opts)
      data
    end

    # Status - Generate WTO
    # Retrieves information status about a particular scheduled wto generation.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param generation_id [String] Unique identifier of the asynchronous job created by a generation endpoint.
    # @param [Hash] opts the optional parameters
    # @return [Array<(ObjectTargetCollectionJobResponse, Integer, Hash)>] ObjectTargetCollectionJobResponse data, response status code and response headers
    def get_wto_status_with_http_info(x_version, x_token, tc_id, generation_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetCollectionApi.get_wto_status ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetCollectionApi.get_wto_status"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetCollectionApi.get_wto_status"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ObjectTargetCollectionApi.get_wto_status"
      end
      # verify the required parameter 'generation_id' is set
      if @api_client.config.client_side_validation && generation_id.nil?
        fail ArgumentError, "Missing the required parameter 'generation_id' when calling ObjectTargetCollectionApi.get_wto_status"
      end
      # resource path
      local_var_path = '/objectTargetCollection/{tcId}/generation/wto/{generationId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s)).sub('{' + 'generationId' + '}', CGI.escape(generation_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body]

      # return_type
      return_type = opts[:debug_return_type] || 'ObjectTargetCollectionJobResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetCollectionApi.get_wto_status",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetCollectionApi#get_wto_status\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update Object Target Collection
    # Updates an existing Object Target Collection in your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param update_object_target_collection_body [UpdateObjectTargetCollectionBody] 
    # @param [Hash] opts the optional parameters
    # @return [ObjectTargetCollectionResponse]
    def update_object_target_collection(x_version, x_token, content_type, tc_id, update_object_target_collection_body, opts = {})
      data, _status_code, _headers = update_object_target_collection_with_http_info(x_version, x_token, content_type, tc_id, update_object_target_collection_body, opts)
      data
    end

    # Update Object Target Collection
    # Updates an existing Object Target Collection in your account.
    # @param x_version [String] The version of the API to be used. Must be set to 3.
    # @param x_token [String] Your Manager Token.
    # @param content_type [String] The Content Type of the body. Must be set to application/json.
    # @param tc_id [String] Unique identifier of the Object Target Collection.
    # @param update_object_target_collection_body [UpdateObjectTargetCollectionBody] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ObjectTargetCollectionResponse, Integer, Hash)>] ObjectTargetCollectionResponse data, response status code and response headers
    def update_object_target_collection_with_http_info(x_version, x_token, content_type, tc_id, update_object_target_collection_body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ObjectTargetCollectionApi.update_object_target_collection ...'
      end
      # verify the required parameter 'x_version' is set
      if @api_client.config.client_side_validation && x_version.nil?
        fail ArgumentError, "Missing the required parameter 'x_version' when calling ObjectTargetCollectionApi.update_object_target_collection"
      end
      # verify the required parameter 'x_token' is set
      if @api_client.config.client_side_validation && x_token.nil?
        fail ArgumentError, "Missing the required parameter 'x_token' when calling ObjectTargetCollectionApi.update_object_target_collection"
      end
      # verify the required parameter 'content_type' is set
      if @api_client.config.client_side_validation && content_type.nil?
        fail ArgumentError, "Missing the required parameter 'content_type' when calling ObjectTargetCollectionApi.update_object_target_collection"
      end
      # verify the required parameter 'tc_id' is set
      if @api_client.config.client_side_validation && tc_id.nil?
        fail ArgumentError, "Missing the required parameter 'tc_id' when calling ObjectTargetCollectionApi.update_object_target_collection"
      end
      # verify the required parameter 'update_object_target_collection_body' is set
      if @api_client.config.client_side_validation && update_object_target_collection_body.nil?
        fail ArgumentError, "Missing the required parameter 'update_object_target_collection_body' when calling ObjectTargetCollectionApi.update_object_target_collection"
      end
      # resource path
      local_var_path = '/objectTargetCollection/{tcId}'.sub('{' + 'tcId' + '}', CGI.escape(tc_id.to_s))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])
      header_params[:'X-Version'] = x_version
      header_params[:'X-Token'] = x_token
      header_params[:'Content-Type'] = content_type

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:debug_body] || @api_client.object_to_http_body(update_object_target_collection_body)

      # return_type
      return_type = opts[:debug_return_type] || 'ObjectTargetCollectionResponse'

      # auth_names
      auth_names = opts[:debug_auth_names] || []

      new_options = opts.merge(
        :operation => :"ObjectTargetCollectionApi.update_object_target_collection",
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ObjectTargetCollectionApi#update_object_target_collection\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
