=begin
#Wikitude Studio API

#The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 

The version of the OpenAPI document: 3.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0

=end

require 'spec_helper'
require 'json'

# Unit tests for WikitudeStudioAPIClient::HeatmapApi
# Automatically generated by openapi-generator (https://openapi-generator.tech)
# Please update as you see appropriate
describe 'HeatmapApi' do
  before do
    # run before each test
    @api_instance = WikitudeStudioAPIClient::HeatmapApi.new
  end

  after do
    # run after each test
  end

  describe 'test an instance of HeatmapApi' do
    it 'should create an instance of HeatmapApi' do
      expect(@api_instance).to be_instance_of(WikitudeStudioAPIClient::HeatmapApi)
    end
  end

  # unit tests for generate_heatmap
  # Generate Heatmap
  # Generates a greyscale image out of the input image, where areas with recognition and tracking relevance are highlighted in color. This way one can better understand the rating of an image and see which areas have the highest importance for 2D recognition and tracking. Note that only JPG and non-transparent PNG files are accepted and the generated heatmap image is stored on a temporary folder which is deleted after 24 hours. Store the image on your own server in case you plan to use it in your user interface. 
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param content_type The Content Type of the body. Must be set to application/json.
  # @param generate_heatmap_body 
  # @param [Hash] opts the optional parameters
  # @return [GenerateHeatmapResponse]
  describe 'generate_heatmap test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_heatmap_status
  # Status - Generate Heatmap
  # Retrieves information status about a particular scheduled heatmap creation.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param generation_id Unique identifier of the asynchronous job created by a generation endpoint.
  # @param [Hash] opts the optional parameters
  # @return [GenerateHeatmapStatusResponse]
  describe 'get_heatmap_status test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

end
