=begin
#Wikitude Studio API

#The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 

The version of the OpenAPI document: 3.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0

=end

require 'spec_helper'
require 'json'

# Unit tests for WikitudeStudioAPIClient::ImageTargetApi
# Automatically generated by openapi-generator (https://openapi-generator.tech)
# Please update as you see appropriate
describe 'ImageTargetApi' do
  before do
    # run before each test
    @api_instance = WikitudeStudioAPIClient::ImageTargetApi.new
  end

  after do
    # run after each test
  end

  describe 'test an instance of ImageTargetApi' do
    it 'should create an instance of ImageTargetApi' do
      expect(@api_instance).to be_instance_of(WikitudeStudioAPIClient::ImageTargetApi)
    end
  end

  # unit tests for create_image_targets
  # Create Image Targets
  # Create a set of up to 10 new Targets in a Target Collection in your account. The task to create the listed Targets is scheduled. The response body contains the initial job status. \&quot;Location\&quot;-header is the url to the GET endpoint that returns current job status information. It is recommended to query this endpoint after \&quot;estimatedLatency\&quot; milliseconds, and poll it afterwards every 10 seconds in case job status is still not \&quot;COMPLETED\&quot;. Once job status is \&quot;COMPLETED\&quot; each item holds a \&quot;target\&quot; attribute of the created target or an \&quot;error\&quot; attribute. 
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param content_type The Content Type of the body. Must be set to application/json.
  # @param tc_id Unique identifier of the Image Target Collection.
  # @param [Hash] opts the optional parameters
  # @option opts [Array<CreateImageTargetsBody>] :create_image_targets_body 
  # @return [CreateImageTargetsResponse]
  describe 'create_image_targets test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for delete_image_target
  # Delete Image Target
  # Delete a particular Target from your account.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Image Target Collection.
  # @param target_id Unique identifier of the Image Target.
  # @param [Hash] opts the optional parameters
  # @return [nil]
  describe 'delete_image_target test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_image_target
  # Get Image Target
  # Request a particular Image Target in a particular Target Collection.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Image Target Collection.
  # @param target_id Unique identifier of the Image Target.
  # @param [Hash] opts the optional parameters
  # @return [ImageTargetResponse]
  describe 'get_image_target test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_image_target_status
  # Status - Image Targets Creation
  # Retrieves information status about a particular scheduled targets creation.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Image Target Collection.
  # @param generation_id Unique identifier of the asynchronous job created by a generation endpoint.
  # @param [Hash] opts the optional parameters
  # @return [CreateImageTargetsResponse]
  describe 'get_image_target_status test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_image_targets
  # Get Image Targets
  # Request all Image Targets in a Target Collection.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Image Target Collection.
  # @param [Hash] opts the optional parameters
  # @option opts [String] :sortby Targets may be sorted by &#39;name&#39;, &#39;creDat&#39;, &#39;modDat&#39;, &#39;rating&#39;. Default value: &#39;creDat&#39;
  # @option opts [String] :sortorder Targets may be sorted ascending (&#39;asc&#39;) or descending (&#39;desc&#39;). Default value: &#39;desc&#39;
  # @option opts [Float] :skip Set 0 to start with first target, set e.g. to 2 to skip first 2 targets. Default value: 0
  # @option opts [Float] :limit Set to 0 for &#39;all targets&#39; or use positive value to define max. amount of targets to return. Default value: 0
  # @option opts [String] :s The search string to look for in target names.
  # @option opts [Boolean] :add_has_augmentations Add the hasAugmentations property.
  # @return [Array<ImageTargetResponse>]
  describe 'get_image_targets test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for update_image_target
  # Update Image Target
  # Updates properties of a particular Target in your account. Currently following properties are supported: physicalHeight, metadata. 
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param content_type The Content Type of the body. Must be set to application/json.
  # @param tc_id Unique identifier of the Image Target Collection.
  # @param target_id Unique identifier of the Image Target.
  # @param update_image_target_body 
  # @param [Hash] opts the optional parameters
  # @return [ImageTargetResponse]
  describe 'update_image_target test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

end
