=begin
#Wikitude Studio API

#The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 

The version of the OpenAPI document: 3.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0

=end

require 'spec_helper'
require 'json'

# Unit tests for WikitudeStudioAPIClient::ImageTargetCollectionApi
# Automatically generated by openapi-generator (https://openapi-generator.tech)
# Please update as you see appropriate
describe 'ImageTargetCollectionApi' do
  before do
    # run before each test
    @api_instance = WikitudeStudioAPIClient::ImageTargetCollectionApi.new
  end

  after do
    # run after each test
  end

  describe 'test an instance of ImageTargetCollectionApi' do
    it 'should create an instance of ImageTargetCollectionApi' do
      expect(@api_instance).to be_instance_of(WikitudeStudioAPIClient::ImageTargetCollectionApi)
    end
  end

  # unit tests for create_image_target_collection
  # Create Image Target Collection
  # Create a new target collection in your account.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param content_type The Content Type of the body. Must be set to application/json.
  # @param create_image_target_collection_body 
  # @param [Hash] opts the optional parameters
  # @return [ImageTargetCollectionResponse]
  describe 'create_image_target_collection test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for delete_image_target_collection
  # Delete Image Target Collection
  # Delete a particular target collection from your account.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Image Target Collection.
  # @param [Hash] opts the optional parameters
  # @return [nil]
  describe 'delete_image_target_collection test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for generate_cloud_archive
  # Generate Cloud Archive
  # DEPRECATED - Generate a Cloud Archive from an existing Target Collection. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate Cloud Archive). As of release 4.0.0 this endpoint will return error TARGET_COLLECTION_IS_UP_TO_DATE with status code 412, since the archive will be generated automatically in the background in the future. This endpoint is marked as \&quot;deprecated\&quot; since the behaviour will slightly change. However, this endpoint will still exist in version 3. 
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Image Target Collection.
  # @param [Hash] opts the optional parameters
  # @return [CloudArchiveGenerationResponse]
  describe 'generate_cloud_archive test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for generate_wtc
  # Generate WTC
  # Generates a WTC file out of an existing Target Collection with up to 1000 targets. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate WTC). 
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param content_type The Content Type of the body. Must be set to application/json.
  # @param tc_id Unique identifier of the Image Target Collection.
  # @param generate_wtc_body 
  # @param [Hash] opts the optional parameters
  # @return [GenerateWTCStatusResponse]
  describe 'generate_wtc test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_cloud_archive_status
  # Status - Generate Cloud Archive
  # Retrieves information status about a particular scheduled cloud archive generation.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Image Target Collection.
  # @param generation_id Unique identifier of the asynchronous job created by a generation endpoint.
  # @param [Hash] opts the optional parameters
  # @return [CloudArchiveGenerationResponse]
  describe 'get_cloud_archive_status test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_image_target_collection
  # Get Image Target Collection
  # Request a particular target collection from your account.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Image Target Collection.
  # @param [Hash] opts the optional parameters
  # @return [ImageTargetCollectionResponse]
  describe 'get_image_target_collection test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_image_target_collections
  # Get all Image Target Collections
  # Request all target collections from your account.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param [Hash] opts the optional parameters
  # @option opts [Integer] :skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0
  # @option opts [Integer] :limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000
  # @return [Array<ImageTargetCollectionResponse>]
  describe 'get_image_target_collections test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_similarity_check_status
  # Status - Similarity Check
  # Retrieves information status of a particular scheduled \&quot;Similarity Check\&quot;.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Image Target Collection.
  # @param generation_id Unique identifier of the asynchronous job created by a generation endpoint.
  # @param [Hash] opts the optional parameters
  # @return [SimilarityCheckStatusResponse]
  describe 'get_similarity_check_status test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_wtc_status
  # Status - Generate WTC
  # Retrieves information status about a particular scheduled WTC file generation. Once the status is completed, the WTC information can be retrieved from the Target Collection (see Get Target Collection). 
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Image Target Collection.
  # @param generation_id Unique identifier of the asynchronous job created by a generation endpoint.
  # @param [Hash] opts the optional parameters
  # @return [GenerateWTCStatusResponse]
  describe 'get_wtc_status test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for similarity_check
  # Similarity Check
  # Pass up to 10 items pointing to PNG or JPEG images hosted via https in the body. In order to find out whether an image is similar to an existing Target in terms of recognition and tracking behaviour a check is performed per passed image item. The Target Collection must be published and have an active Cloud Archive in place. Up to 5 (default: 1) so called \&quot;candidates\&quot; with a similarity \&quot;score\&quot; are returned per image. Image must be hosted via https and be of type PNG or JPEG. Use \&quot;maxCandidates\&quot; to define the maximum amount of candidates to return for an image. Response header value \&quot;Location\&quot; directly points to the right \&quot;Status - Similarity Check\&quot; endpoint. Best practice is to trigger \&quot;Similarity Check\&quot;, wait for \&quot;estimatedLatency\&quot; milliseconds and poll \&quot;Status - Similarity Check\&quot; endpoint every 5 seconds until its \&quot;status\&quot; is \&quot;COMPLETED\&quot;. 
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param content_type The Content Type of the body. Must be set to application/json.
  # @param tc_id Unique identifier of the Image Target Collection.
  # @param similarity_check_body 
  # @param [Hash] opts the optional parameters
  # @return [SimilarityCheckResponse]
  describe 'similarity_check test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for update_image_target_collection
  # Update Image Target Collection
  # Update a target collection from your account.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param content_type The Content Type of the body. Must be set to application/json.
  # @param tc_id Unique identifier of the Image Target Collection.
  # @param update_image_target_collection_body 
  # @param [Hash] opts the optional parameters
  # @return [ImageTargetCollectionResponse]
  describe 'update_image_target_collection test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

end
