=begin
#Wikitude Studio API

#The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 

The version of the OpenAPI document: 3.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0

=end

require 'spec_helper'
require 'json'

# Unit tests for WikitudeStudioAPIClient::ObjectTargetApi
# Automatically generated by openapi-generator (https://openapi-generator.tech)
# Please update as you see appropriate
describe 'ObjectTargetApi' do
  before do
    # run before each test
    @api_instance = WikitudeStudioAPIClient::ObjectTargetApi.new
  end

  after do
    # run after each test
  end

  describe 'test an instance of ObjectTargetApi' do
    it 'should create an instance of ObjectTargetApi' do
      expect(@api_instance).to be_instance_of(WikitudeStudioAPIClient::ObjectTargetApi)
    end
  end

  # unit tests for create_object_target_from_images
  # Create Object Target from Images
  # Create a new Object Target in an Object Target Collection from at least two Image files.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param content_type The Content Type of the body. Must be set to application/json.
  # @param tc_id Unique identifier of the Object Target Collection.
  # @param create_object_target_images_body 
  # @param [Hash] opts the optional parameters
  # @return [ObjectTargetJobResponse]
  describe 'create_object_target_from_images test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for create_object_target_from_wto
  # Create Object Target from WTO
  # Create a new Object Target in an Object Target Collection from a WTO file.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param content_type The Content Type of the body. Must be set to application/json.
  # @param tc_id Unique identifier of the Object Target Collection.
  # @param create_object_target_wto_body 
  # @param [Hash] opts the optional parameters
  # @return [ObjectTargetJobResponse]
  describe 'create_object_target_from_wto test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for delete_object_target
  # Delete Object Target
  # Delete a particular Object Target from your Object Target Collection.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Object Target Collection.
  # @param target_id Unique identifier of the Object Target.
  # @param [Hash] opts the optional parameters
  # @return [nil]
  describe 'delete_object_target test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for extend_object_target
  # Extend Object Target
  # Add source images to an existing target.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param content_type The Content Type of the body. Must be set to application/json.
  # @param tc_id Unique identifier of the Object Target Collection.
  # @param target_id Unique identifier of the Object Target.
  # @param extend_object_target_body 
  # @param [Hash] opts the optional parameters
  # @return [ObjectTargetJobResponse]
  describe 'extend_object_target test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_object_target
  # Get Object Target
  # Request a specific Object Targets from your account.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Object Target Collection.
  # @param target_id Unique identifier of the Object Target.
  # @param [Hash] opts the optional parameters
  # @return [ObjectTargetResponse]
  describe 'get_object_target test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_object_target_status
  # Status - Object Target Generation Information
  # Retrieves information status about a particular scheduled Object Target creation.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Object Target Collection.
  # @param generation_id Unique identifier of the asynchronous job created by a generation endpoint.
  # @param [Hash] opts the optional parameters
  # @return [ObjectTargetJobResponse]
  describe 'get_object_target_status test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_object_targets
  # Get Object Targets
  # Request all Object Targets in a Target Collection.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Object Target Collection.
  # @param [Hash] opts the optional parameters
  # @return [Array<ObjectTargetResponse>]
  describe 'get_object_targets test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for rename_object_target
  # Rename Object Target
  # Rename an existing target.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param content_type The Content Type of the body. Must be set to application/json.
  # @param tc_id Unique identifier of the Object Target Collection.
  # @param target_id Unique identifier of the Object Target.
  # @param rename_object_target_body 
  # @param [Hash] opts the optional parameters
  # @return [ObjectTargetJobResponse]
  describe 'rename_object_target test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

end
