=begin
#Wikitude Studio API

#The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 

The version of the OpenAPI document: 3.0.0

Generated by: https://openapi-generator.tech
OpenAPI Generator version: 5.1.0

=end

require 'spec_helper'
require 'json'

# Unit tests for WikitudeStudioAPIClient::ObjectTargetCollectionApi
# Automatically generated by openapi-generator (https://openapi-generator.tech)
# Please update as you see appropriate
describe 'ObjectTargetCollectionApi' do
  before do
    # run before each test
    @api_instance = WikitudeStudioAPIClient::ObjectTargetCollectionApi.new
  end

  after do
    # run after each test
  end

  describe 'test an instance of ObjectTargetCollectionApi' do
    it 'should create an instance of ObjectTargetCollectionApi' do
      expect(@api_instance).to be_instance_of(WikitudeStudioAPIClient::ObjectTargetCollectionApi)
    end
  end

  # unit tests for create_object_target_collection
  # Create Object Target Collection
  # Create a new Object Target Collection in your account.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param content_type The Content Type of the body. Must be set to application/json.
  # @param create_object_target_collection_body 
  # @param [Hash] opts the optional parameters
  # @return [ObjectTargetCollectionResponse]
  describe 'create_object_target_collection test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for delete_object_target_collection
  # Delete Object Target Collection
  # Delete a Object Target Collection and all its Object Targets.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Object Target Collection.
  # @param [Hash] opts the optional parameters
  # @return [nil]
  describe 'delete_object_target_collection test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for generate_wto
  # Generate WTO
  # Generate a WTO file containing the Object Target Collection and all its Object Targets.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param content_type The Content Type of the body. Must be set to application/json.
  # @param tc_id Unique identifier of the Object Target Collection.
  # @param generate_wto_body 
  # @param [Hash] opts the optional parameters
  # @return [ObjectTargetCollectionJobResponse]
  describe 'generate_wto test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_object_target_collection
  # Get Object Target Collection
  # Request a particular Object Target Collection from your account.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Object Target Collection.
  # @param [Hash] opts the optional parameters
  # @return [ObjectTargetCollectionResponse]
  describe 'get_object_target_collection test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_object_target_collection_status
  # Status - Get Object Target Collection jobs
  # Retrieves a list of asynchronous jobs sorted by creation date.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Object Target Collection.
  # @param [Hash] opts the optional parameters
  # @option opts [Integer] :skip Set 0 to start with first collection, set e.g. to 2 to skip first 2 collections. Default value: 0
  # @option opts [Integer] :limit Use positive value to define the amount of entries to return [1, 20] per page. Default value: 10
  # @option opts [String] :source filter the jobs by source. Available values (api, studio). Default value: api
  # @option opts [String] :type filter the jobs by type.
  # @return [Array<ObjectTargetJobResponse>]
  describe 'get_object_target_collection_status test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_object_target_collections
  # Get all Object Target Collections
  # Request all Object Target Collections from your account.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param [Hash] opts the optional parameters
  # @option opts [Integer] :skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0
  # @option opts [Integer] :limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000
  # @return [Array<ObjectTargetCollectionResponse>]
  describe 'get_object_target_collections test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for get_wto_status
  # Status - Generate WTO
  # Retrieves information status about a particular scheduled wto generation.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param tc_id Unique identifier of the Object Target Collection.
  # @param generation_id Unique identifier of the asynchronous job created by a generation endpoint.
  # @param [Hash] opts the optional parameters
  # @return [ObjectTargetCollectionJobResponse]
  describe 'get_wto_status test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

  # unit tests for update_object_target_collection
  # Update Object Target Collection
  # Updates an existing Object Target Collection in your account.
  # @param x_version The version of the API to be used. Must be set to 3.
  # @param x_token Your Manager Token.
  # @param content_type The Content Type of the body. Must be set to application/json.
  # @param tc_id Unique identifier of the Object Target Collection.
  # @param update_object_target_collection_body 
  # @param [Hash] opts the optional parameters
  # @return [ObjectTargetCollectionResponse]
  describe 'update_object_target_collection test' do
    it 'should work' do
      # assertion here. ref: https://www.relishapp.com/rspec/rspec-expectations/docs/built-in-matchers
    end
  end

end
